import { IEffectsAction } from 'redux-effects-promise';
import { IChannelMessageEntity, IReduxChannelHolderEntity } from '../definition';
import { AnyT } from '../definitions.interface';
export declare class ChannelActionBuilder {
    /**
     * @stable [06.11.2020]
     * @param payload
     */
    static buildReceiveMessagePlainAction<TData = AnyT>(payload: IChannelMessageEntity<TData>): IEffectsAction;
    /**
     * @stable [06.11.2020]
     * @param payload
     */
    static buildReceiveMessageAction<TData = AnyT>(payload: IChannelMessageEntity<TData>): IEffectsAction;
    /**
     * @stable [06.11.2020]
     * @param payload
     */
    static buildReplaceMessagesPlainAction<TData = AnyT>(payload: IChannelMessageEntity<TData>): IEffectsAction;
    /**
     * @stable [06.11.2020]
     * @param payload
     */
    static buildReplaceMessagesAction<TData = AnyT>(payload: IChannelMessageEntity<TData>): IEffectsAction;
    /**
     * @stable [06.11.2020]
     * @param payload
     * @param wrapper
     * @param errorHandler
     */
    static buildFilteredCommandResultMessagesAction<TResult = {}>(payload: IChannelMessageEntity, wrapper: IReduxChannelHolderEntity, errorHandler?: (resultData: TResult) => string): IEffectsAction[];
}
