"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterFormDialogActionBuilder = void 0;
var definition_1 = require("../definition");
var util_1 = require("../util");
/**
 * @action-builder
 * @stable [08.09.2020]
 */
var FilterFormDialogActionBuilder = /** @class */ (function () {
    function FilterFormDialogActionBuilder() {
    }
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterFormDialogActionBuilder.buildResetActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_FORM_DIALOG_RESET_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterFormDialogActionBuilder.buildAcceptActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_FORM_DIALOG_ACCEPT_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterFormDialogActionBuilder.buildClearActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.FILTER_FORM_DIALOG_CLEAR_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterFormDialogActionBuilder.buildResetPlainAction = function (section) {
        return { type: this.buildResetActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterFormDialogActionBuilder.buildAcceptPlainAction = function (section) {
        return { type: this.buildAcceptActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    FilterFormDialogActionBuilder.buildClearPlainAction = function (section) {
        return { type: this.buildClearActionType(section), data: util_1.SectionUtils.applySection(section) };
    };
    return FilterFormDialogActionBuilder;
}());
exports.FilterFormDialogActionBuilder = FilterFormDialogActionBuilder;
//# sourceMappingURL=filter-form-dialog-action.builder.js.map