"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericComponent = void 0;
var React = require("react");
var di_1 = require("../../di");
var util_1 = require("../../util");
var GenericComponent = /** @class */ (function (_super) {
    __extends(GenericComponent, _super);
    function GenericComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.selfRef = React.createRef();
        return _this;
    }
    Object.defineProperty(GenericComponent.prototype, "actualRef", {
        /**
         * @stable [19.09.2020]
         */
        get: function () {
            return this.props.forwardedRef || this.selfRef;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "settings", {
        /**
         * @stable [19.09.2020]
         */
        get: function () {
            return this.$settings = this.$settings || di_1.getSettings();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "originalProps", {
        /**
         * @stable [19.09.2020]
         */
        get: function () {
            return this.props;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "originalChildren", {
        /**
         * @stable [19.09.2020]
         */
        get: function () {
            return this.props.children;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "mergedProps", {
        /**
         * @stable [12.10.2020]
         * @protected
         */
        get: function () {
            var originalProps = this.originalProps;
            var noMergedProps = originalProps.noMergedProps;
            return noMergedProps
                ? originalProps
                : util_1.PropsUtils.mergeWithSystemProps(originalProps, this.componentsSettingsProps);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "componentsSettingsProps", {
        /**
         * @stable [10.08.2020]
         * @protected
         */
        get: function () {
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "componentsSettings", {
        /**
         * @stable [21.05.2020]
         * @returns {IComponentsSettingsEntity}
         */
        get: function () {
            return this.settings.components;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "eventEmitter", {
        /**
         * @stable [01.06.2020]
         * @returns {IEventEmitter}
         */
        get: function () {
            return this.$eventEmitter = this.$eventEmitter || di_1.getEventEmitter();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "databaseStorage", {
        /**
         * @stable [21.04.2020]
         * @returns {IStorage}
         */
        get: function () {
            return this.$databaseStorage = this.$databaseStorage || di_1.getDatabaseStorage();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "asyncLibManager", {
        /**
         * @stable [18.05.2020]
         * @returns {IAsyncLibManager}
         */
        get: function () {
            return this.$asyncLibManager = this.$asyncLibManager || di_1.getAsyncLibManager();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "transport", {
        /**
         * @stable [21.04.2020]
         * @returns {ITransport}
         */
        get: function () {
            return this.$transport = this.$transport || di_1.getTransport();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "nc", {
        /**
         * @stable [30.03.2020]
         * @returns {INumberConverter}
         */
        get: function () {
            return this.$nc = this.$nc || di_1.getNumberConverter();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "fieldConverter", {
        /**
         * @stable [27.09.2020]
         */
        get: function () {
            return this.$fieldConverter = this.$fieldConverter || di_1.DiServices.fieldConverter();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "pc", {
        /**
         * @stable [30.11.2020]
         * @protected
         */
        get: function () {
            return this.$pc = this.$pc || di_1.DiServices.phoneConverter();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "dc", {
        /**
         * @stable [30.03.2020]
         * @returns {IDateConverter}
         */
        get: function () {
            return this.$dc = this.$dc || di_1.getDateConverter();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "placeApi", {
        /**
         * @stable [21.04.2020]
         * @returns {IPlaceApi}
         */
        get: function () {
            return this.$placeApi = this.$placeApi || di_1.getPlaceApi();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "environment", {
        /**
         * @stable [21.04.2020]
         * @returns {IEnvironment}
         */
        get: function () {
            return this.$environment = this.$environment || di_1.getEnvironment();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "eventManager", {
        /**
         * @stable [30.03.2020]
         * @returns {IEventManager}
         */
        get: function () {
            return this.$eventManager = this.$eventManager || di_1.getEventManager();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "t", {
        /**
         * @stable [18.03.2020]
         * @returns {TranslatorT}
         */
        get: function () {
            return this.$t = this.$t || di_1.getTranslator();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "uiFactory", {
        /**
         * @stable [19.06.2020]
         * @returns {IUiFactory}
         */
        get: function () {
            return this.$uiFactory = this.$uiFactory || di_1.DiServices.uiFactory();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "domAccessor", {
        /**
         * @stable [05.04.2020]
         * @returns {IDomAccessor}
         */
        get: function () {
            return this.$domAccessor = this.$domAccessor || di_1.getDomAccessor();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GenericComponent.prototype, "viewerLocator", {
        /**
         * @stable [19.06.2020]
         * @returns {IViewerLocator}
         */
        get: function () {
            return this.$viewerLocator = this.$viewerLocator || di_1.DiServices.viewerLocator();
        },
        enumerable: false,
        configurable: true
    });
    return GenericComponent;
}(React.PureComponent));
exports.GenericComponent = GenericComponent;
//# sourceMappingURL=generic.component.js.map