"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConnectorContainerFactory = void 0;
var inversify_1 = require("inversify");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../../util");
var action_1 = require("../../../action");
var di_1 = require("../../../di");
var ConnectorContainerFactory = /** @class */ (function () {
    function ConnectorContainerFactory() {
    }
    ConnectorContainerFactory_1 = ConnectorContainerFactory;
    /**
     * @stable [18.09.2020]
     * @param target
     * @param section
     */
    ConnectorContainerFactory.prototype.fromTarget = function (target, section) {
        var dynamicSections = this.dynamicSections;
        var environment = this.environment;
        // tslint:disable:max-classes-per-file
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            /**
             * @stable [18.09.2020]
             * @param originalProps
             */
            function class_1(originalProps) {
                var _this = _super.call(this, originalProps) || this;
                _this.state = _this.state || {};
                ConnectorContainerFactory_1.logger.debug("[$ConnectorContainerFactory][constructor] Section: " + section);
                return _this;
            }
            /**
             * @stable [18.09.2020]
             */
            class_1.prototype.render = function () {
                var error = this.state.error;
                if (error) {
                    if (this.rootPathOfFirstStackItem) {
                        return null;
                    }
                    return this.uiFactory.makeReactError(error);
                }
                try {
                    if (util_1.TypeUtils.isFn(_super.prototype.render)) {
                        return _super.prototype.render.call(this);
                    }
                    else {
                        return null;
                    }
                }
                catch (e) {
                    ConnectorContainerFactory_1.logger.error("[$ConnectorContainerFactory][render] Error:", error);
                    return this.uiFactory.makeReactError(e);
                }
            };
            /**
             * @stable [11.06.2020]
             */
            class_1.prototype.componentWillUnmount = function () {
                this.$dispatch(action_1.StackActionBuilder.buildPopPlainAction({ section: section }));
                this.$dispatch(action_1.ConnectorActionBuilder.buildDestroyPlainAction(section));
                ConnectorContainerFactory_1.logger.debug("[$ConnectorContainerFactory][componentWillUnmount] Section: " + section);
                if (util_1.TypeUtils.isFn(_super.prototype.componentWillUnmount)) {
                    _super.prototype.componentWillUnmount.call(this);
                }
            };
            /**
             * @stable [11.06.2020]
             */
            class_1.prototype.componentDidMount = function () {
                this.$dispatch(action_1.StackActionBuilder.buildPushPlainAction({ section: section, url: environment.path }));
                this.$dispatch(action_1.ConnectorActionBuilder.buildInitPlainAction(section));
                ConnectorContainerFactory_1.logger.debug("[$ConnectorContainerFactory][componentDidMount] Section: " + section);
                if (util_1.TypeUtils.isFn(_super.prototype.componentDidMount)) {
                    _super.prototype.componentDidMount.call(this);
                }
            };
            /**
             * @stable [19.09.2020]
             * @param prevProps
             * @param prevState
             * @param snapshot
             */
            class_1.prototype.componentDidUpdate = function (prevProps, prevState, snapshot) {
                if (util_1.TypeUtils.isFn(_super.prototype.componentDidUpdate)) {
                    _super.prototype.componentDidUpdate.call(this, prevProps, prevState, snapshot);
                }
                if (util_1.ObjectUtils.isCurrentValueNotEqualPreviousValue(this.state.error, prevState.error)) {
                    var rootPathOfFirstStackItem = this.rootPathOfFirstStackItem;
                    if (rootPathOfFirstStackItem) {
                        this.$dispatch(action_1.RouterActionBuilder.buildNavigatePlainAction(rootPathOfFirstStackItem));
                    }
                }
            };
            /**
             * @stable [19.09.2020]
             * @param error
             * @param errorInfo
             */
            class_1.prototype.componentDidCatch = function (error, errorInfo) {
                if (util_1.TypeUtils.isFn(_super.prototype.componentDidCatch)) {
                    _super.prototype.componentDidCatch.call(this, error, errorInfo);
                }
                ConnectorContainerFactory_1.logger.error("[$ConnectorContainerFactory][componentDidCatch] Error:", error);
                this.setState({ error: error });
            };
            /**
             * @stable [19.09.2020]
             * @param action
             */
            class_1.prototype.$dispatch = function (action) {
                this.originalProps.dispatch(action);
            };
            Object.defineProperty(class_1.prototype, "rootPathOfFirstStackItem", {
                /**
                 * @stable [18.09.2020]
                 */
                get: function () {
                    return util_1.ConditionUtils.ifNotNilThanValue(util_1.Selectors.firstStackItemEntity(this.originalProps), function (firstStackItemEntity) {
                        return util_1.ConditionUtils.ifNotNilThanValue(dynamicSections.get(firstStackItemEntity.section), function (connectorEntity) {
                            return util_1.ConditionUtils.ifNotNilThanValue(connectorEntity.routeConfiguration.rootPath, function (rootPath) { return rootPath; });
                        });
                    });
                },
                enumerable: false,
                configurable: true
            });
            Object.defineProperty(class_1.prototype, "originalProps", {
                /**
                 * @stable [19.09.2020]
                 */
                get: function () {
                    return this.props;
                },
                enumerable: false,
                configurable: true
            });
            Object.defineProperty(class_1.prototype, "uiFactory", {
                /**
                 * @stable [19.09.2020]
                 */
                get: function () {
                    return di_1.DiServices.uiFactory(); // Without injection (!), because runtime service may be overridden
                },
                enumerable: false,
                configurable: true
            });
            return class_1;
        }(target));
        // tslint:enable:max-classes-per-file
    };
    var ConnectorContainerFactory_1;
    ConnectorContainerFactory.logger = ts_smart_logger_1.LoggerFactory.makeLogger('ConnectorContainerFactory');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.DynamicSections),
        __metadata("design:type", Object)
    ], ConnectorContainerFactory.prototype, "dynamicSections", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Environment),
        __metadata("design:type", Object)
    ], ConnectorContainerFactory.prototype, "environment", void 0);
    ConnectorContainerFactory = ConnectorContainerFactory_1 = __decorate([
        inversify_1.injectable()
    ], ConnectorContainerFactory);
    return ConnectorContainerFactory;
}());
exports.ConnectorContainerFactory = ConnectorContainerFactory;
//# sourceMappingURL=connector-container-factory.service.js.map