import { IBasicConnectorEntity, IConnectorEntity, IGenericContainerCtor, IReduxStoreEntity, IUniversalStoreEntity } from '../../definition';
/**
 * @stable - 23.04.2018
 * @param {IBasicConnectorEntity<TStoreEntity>} config
 * @returns {(target: IContainerClassEntity) => void}
 */
export declare const basicConnector: <TStoreEntity extends IReduxStoreEntity<{}> = IReduxStoreEntity<{}>>(config: IBasicConnectorEntity<TStoreEntity>) => (target: IGenericContainerCtor) => void;
/**
 * @stable - 23.04.2018
 * @param {IConnectorEntity<TStoreEntity extends IUniversalStoreEntity, TAccessConfig>} config
 * @returns {(target: IContainerClassEntity) => void}
 */
export declare const connector: <TStoreEntity extends IUniversalStoreEntity<{}, {}>, TAccessConfig>(config: IConnectorEntity<TStoreEntity, TAccessConfig>) => (target: IGenericContainerCtor) => void;
