import * as React from 'react';
import { IActivateDialogConfigEntity, IDialog, IDialogProps, IDialogState } from '../../definition';
import { GenericComponent } from '../base/generic.component';
/**
 * @component-impl
 * @stable [10.10.2020]
 */
export declare class BaseDialog<TProps extends IDialogProps = IDialogProps, TState extends IDialogState = IDialogState> extends GenericComponent<TProps, TState> implements IDialog<TProps, TState> {
    static readonly defaultProps: IDialogProps;
    private $closeEventUnsubscriber;
    private $onDeactivateCallback;
    private $isCheckNeededAndAnotherModalDialogOpen;
    private readonly bodyRef;
    /**
     * @stable [10.10.2020]
     * @param originalProps
     */
    constructor(originalProps: TProps);
    /**
     * @stable [10.10.2020]
     */
    render(): React.ReactNode;
    /**
     * @stable [10.10.2020]
     */
    componentDidMount(): void;
    /**
     * @stable [10.10.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [10.10.2020]
     * @param payload
     */
    activate(payload?: IActivateDialogConfigEntity): void;
    /**
     * @stable [10.10.2020]
     */
    close(): void;
    /**
     * @stable [10.10.2020]
     */
    protected onAcceptClick(): void;
    /**
     * @stable [10.10.2020]
     */
    protected onCloseClick(): void;
    /**
     * @stable [10.10.2020]
     */
    protected get title(): string | boolean;
    /**
     * @stable [10.10.2020]
     */
    protected get closeText(): string;
    /**
     * @stable [10.10.2020]
     */
    protected get acceptText(): string;
    /**
     * @stable [10.10.2020]
     */
    private onDialogClick;
    /**
     * @stable [10.10.2020]
     */
    private onDocumentClickCapture;
    /**
     * @stable [10.10.2020]
     */
    private onDestroy;
    /**
     * @stable [10.10.2020]
     */
    private onAfterRender;
    /**
     * @stable [10.10.2020]
     * @param callback
     */
    private doClose;
    /**
     * @stable [10.10.2020]
     */
    private get actionsElement();
    /**
     * @stable [10.10.2020]
     */
    private get dialogBodyElement();
    /**
     * @stable [10.10.2020]
     */
    private get titleElement();
    /**
     * @stable [10.10.2020]
     */
    private get extraActionsElement();
    /**
     * @stable [10.10.2020]
     */
    private get bodyElement();
    /**
     * @stable [10.10.2020]
     */
    private unsubscribeEvents;
    /**
     * @stable [10.10.2020]
     */
    private showOverlayIfApplicable;
    /**
     * @stable [10.10.2020]
     */
    private closeOverlayIfApplicable;
    /**
     * @stable [10.10.2020]
     */
    private get progressElement();
    /**
     * @stable [10.10.2020]
     */
    private get closeOverlayActionElement();
    /**
     * @stable [10.10.2020]
     */
    private get acceptable();
    /**
     * @stable [10.10.2020]
     */
    private get closable();
    /**
     * @stable [10.10.2020]
     */
    private get portalElement();
    /**
     * @stable [10.10.2020]
     */
    private get isAnchored();
    /**
     * @stable [10.10.2020]
     */
    private get isInline();
    /**
     * @stable [10.10.2020]
     */
    private get isDefault();
    /**
     * @stable [10.10.2020]
     */
    private get isOverlay();
    /**
     * @stable [10.10.2020]
     */
    private get isConfirm();
    /**
     * @stable [10.10.2020]
     */
    private get isWide();
    /**
     * @stable [10.10.2020]
     */
    private get isModal();
    /**
     * @stable [10.10.2020]
     */
    private get hasExtraActions();
    /**
     * @stable [10.10.2020]
     */
    private get isScrollable();
    /**
     * @stable [10.10.2020]
     */
    private get isDialogInProgress();
    /**
     * @stable [10.10.2020]
     */
    private get wrapperPlugins();
    /**
     * @stable [10.10.2020]
     */
    private get dialogClassName();
    /**
     * @stable [10.10.2020]
     */
    private get isCheckNeededAndAnotherModalDialogOpen();
    /**
     * @stable [10.10.2020]
     */
    protected get componentsSettingsProps(): TProps;
}
