"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Field = void 0;
var React = require("react");
var R = require("ramda");
var Printf = require("sprintf-js");
var definitions_interface_1 = require("../../../definitions.interface");
var definition_1 = require("../../../definition");
var util_1 = require("../../../util");
var info_component_1 = require("../../info/info.component");
var enhanced_generic_component_1 = require("../../base/enhanced-generic.component");
var keyboard_component_1 = require("../../keyboard/keyboard.component");
var Field = /** @class */ (function (_super) {
    __extends(Field, _super);
    /**
     * @stable [14.10.2020]
     * @param originalProps
     */
    function Field(originalProps) {
        var _this = _super.call(this, originalProps) || this;
        /**/
        _this.inputRef = React.createRef();
        /**/
        _this.inputMirrorRef = React.createRef(); // TODO -> private
        _this.keyboardRef = React.createRef();
        _this.state = {};
        _this.closeVirtualKeyboard = _this.closeVirtualKeyboard.bind(_this);
        _this.doCancelEvent = _this.doCancelEvent.bind(_this);
        _this.onBlur = _this.onBlur.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        _this.onChangeManually = _this.onChangeManually.bind(_this);
        _this.onClick = _this.onClick.bind(_this);
        _this.onCloseVirtualKeyboard = _this.onCloseVirtualKeyboard.bind(_this);
        _this.onDocumentClickHandler = _this.onDocumentClickHandler.bind(_this);
        _this.onFocus = _this.onFocus.bind(_this);
        _this.onKeyboardChange = _this.onKeyboardChange.bind(_this);
        _this.onKeyDown = _this.onKeyDown.bind(_this);
        _this.onKeyUp = _this.onKeyUp.bind(_this);
        if (_this.isKeyboardAndCursorUsed) {
            var caretBlinkingFrequency = _this.mergedProps.caretBlinkingFrequency;
            _this.caretBlinkingTask = new util_1.DelayedTask(_this.setCaretVisibility.bind(_this), caretBlinkingFrequency || 400, true);
        }
        return _this;
    }
    /**
     * @stable [21.08.2020]
     */
    Field.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { className: this.getFieldClassName(), onClick: this.doCancelEvent },
            this.originalChildren,
            this.displayValueElement,
            this.selfElement,
            this.attachmentElement,
            util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.message, function (message) { return _this.messageElement(message); }),
            util_1.ConditionUtils.orNull(this.isErrorMessageRendered, function () { return _this.messageElement(_this.error, definition_1.FieldClassesEnum.ERROR_MESSAGE); }),
            util_1.ConditionUtils.orNull(this.isKeyboardUsed && this.isKeyboardOpen, function () { return _this.keyboardElement; })));
    };
    /**
     * @stable [21.06.2020]
     */
    Field.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        // Need to invoke a user validator if it exists (After F5, etc...)
        this.validateValueAndSetCustomValidity(this.value);
        var autoFocus = this.originalProps.autoFocus;
        if (autoFocus) {
            this.setFocus();
        }
    };
    /**
     * @stable [21.06.2020]
     */
    Field.prototype.componentWillUnmount = function () {
        _super.prototype.componentWillUnmount.call(this);
        this.onCloseVirtualKeyboard();
    };
    /**
     * @stable [13.10.2020]
     * @param prevProps
     * @param prevState
     */
    Field.prototype.componentDidUpdate = function (prevProps, prevState) {
        if (this.isKeyboardUsed) {
            if (this.isKeyboardOpen && !R.equals(this.originalProps.value, prevProps.value)) {
                this.refreshCaretPosition();
            }
        }
        else if (prevProps.useKeyboard) {
            this.closeVirtualKeyboard();
        }
        _super.prototype.componentDidUpdate.call(this, prevProps, prevState);
    };
    /**
     * @stable [19.10.2020]
     * @param event
     */
    Field.prototype.onChange = function (event) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.onChangeValue(this.getRawValueFromEvent(event));
                return [2 /*return*/];
            });
        });
    };
    /**
     * @stable [14.10.2020]
     * @param currentRawValue
     */
    Field.prototype.onChangeManually = function (currentRawValue) {
        var _this = this;
        if (this.areManualChangesPrevented) {
            return;
        }
        util_1.ConditionUtils.ifNotNilThanValue(this.input, function (input) {
            // We should update the field manually before calls the HTML5 validation
            input.value = _this.getDecoratedDisplayValue(currentRawValue);
        });
        this.onChangeValue(currentRawValue);
    };
    /**
     * @stable [21.06.2020]
     */
    Field.prototype.setFocus = function () {
        var _this = this;
        util_1.ConditionUtils.ifNotNilThanValue(this.input, function (input) {
            if (!_this.isFocusPrevented) {
                input.focus();
            }
        });
    };
    Object.defineProperty(Field.prototype, "value", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            var value = this.originalProps.value;
            return this.isValueDefined(value) ? value : this.defaultValue;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.onKeyDown = function (event) {
        var key = event.key;
        switch (key) {
            case 'Tab':
                this.onKeyTab(event);
                break;
            case 'Enter':
                this.onKeyEnter(event);
                break;
            case 'Escape':
                this.onKeyEscape(event);
                break;
            case 'ArrowDown':
                this.onKeyArrowDown(event);
                break;
            case 'ArrowUp':
                this.onKeyArrowUp(event);
                break;
            case 'Backspace':
                this.onKeyBackspace(event);
                break;
        }
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyDown, function (onKeyDown) { return onKeyDown(event); });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.onKeyEnter = function (event) {
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyEnter, function (onKeyEnter) { return onKeyEnter(event); });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     * @private
     */
    Field.prototype.onKeyUp = function (event) {
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyUp, function (onKeyUp) { return onKeyUp(event); });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.onKeyBackspace = function (event) {
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyBackspace, function (onKeyBackspace) { return onKeyBackspace(event); });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.onKeyTab = function (event) {
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyTab, function (onKeyTab) { return onKeyTab(event); });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.onKeyEscape = function (event) {
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyEscape, function (onKeyEscape) { return onKeyEscape(event); });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.onKeyArrowDown = function (event) {
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyArrowDown, function (onKeyArrowDown) { return onKeyArrowDown(event); });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.onKeyArrowUp = function (event) {
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onKeyArrowUp, function (onKeyArrowUp) { return onKeyArrowUp(event); });
    };
    /**
     * @stable [19.10.2020]
     * @protected
     */
    Field.prototype.clearValue = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.isValuePresent) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.doClearValue()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onClear, function (onClear) { return onClear(); });
                        this.setFocus();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [19.10.2020]
     * @protected
     */
    Field.prototype.doClearValue = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.onChangeManually(this.emptyValue);
                return [2 /*return*/];
            });
        });
    };
    /**
     * @stable [14.10.2020]
     * @param event
     */
    Field.prototype.getRawValueFromEvent = function (event) {
        return event.target.value;
    };
    Object.defineProperty(Field.prototype, "input", {
        /**
         * @stable [15.10.2020]
         * @protected
         */
        get: function () {
            return util_1.ConditionUtils.ifNotNilThanValue(this.inputRef.current, function (input) { return input.inputElement || input; });
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [05.06.2020]
     */
    Field.prototype.removeFocus = function () {
        if (this.hasInput) {
            this.input.blur();
        }
    };
    /**
     * @stable [07.10.2020]
     */
    Field.prototype.getFieldPattern = function () {
        return this.originalProps.pattern;
    };
    Object.defineProperty(Field.prototype, "keyboardElement", {
        get: function () {
            return (React.createElement(keyboard_component_1.Keyboard, __assign({ forwardedRef: this.keyboardRef, field: this, onClose: this.closeVirtualKeyboard, onChange: this.onKeyboardChange }, this.getKeyboardProps())));
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [21.06.2020]
     * @param {IFocusEvent} event
     */
    Field.prototype.onFocus = function (event) {
        var _this = this;
        if (this.isFocusPrevented || this.isKeyboardUsed) {
            this.removeFocus(); // Prevent native keyboard opening during use of a synthetic keyboard
            if (this.isKeyboardUsed) {
                this.openVirtualKeyboard();
            }
        }
        else {
            this.setState({ focused: true }, function () { return util_1.ConditionUtils.ifNotNilThanValue(_this.originalProps.onFocus, function (onFocus) { return onFocus(event); }); });
        }
    };
    /**
     * @stable [14.10.2020]
     * @param event
     * @protected
     */
    Field.prototype.onBlur = function (event) {
        var _this = this;
        this.setState({ focused: false }, function () { return util_1.ConditionUtils.ifNotNilThanValue(_this.originalProps.onBlur, function (onBlur) { return onBlur(event); }); });
    };
    Field.prototype.openVirtualKeyboard = function () {
        var _this = this;
        if (this.isKeyboardOpen) {
            return;
        }
        this.setState({ keyboardOpen: true }, function () {
            if (!_this.isInlineKeyboard) {
                _this.keyboardListenerUnsubscriber = _this.domAccessor.captureEvent({
                    element: _this.environment.document,
                    callback: _this.onDocumentClickHandler,
                    capture: true,
                    eventName: _this.environment.touchedPlatform ? definition_1.TouchEventsEnum.TOUCH_START : definition_1.EventsEnum.MOUSE_DOWN,
                });
            }
            if (util_1.TypeUtils.isDef(_this.caretBlinkingTask)) {
                _this.caretBlinkingTask.start();
                // Need to refresh a caret position right after keyboard opening
                _this.refreshCaretPosition();
            }
        });
    };
    /**
     * @stable [18.10.2020]
     * @param event
     * @protected
     */
    Field.prototype.onClick = function (event) {
        this.doCancelEvent(event);
        util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onClick, function (onClick) { return onClick(event); });
    };
    /**
     * @stable [19.10.2020]
     * @param event
     * @protected
     */
    Field.prototype.doCancelEvent = function (event) {
        this.domAccessor.cancelEvent(event);
    };
    /**
     * @stable [18.05.2020]
     * @param {AnyT} value
     * @param {boolean} forceApplyValue
     * @returns {AnyT}
     */
    Field.prototype.getDecoratedDisplayValue = function (value, forceApplyValue) {
        if (forceApplyValue === void 0) { forceApplyValue = false; }
        var displayValue = this.originalProps.displayValue;
        return R.isNil(displayValue)
            ? this.decorateDisplayValue(value)
            : (util_1.TypeUtils.isFn(displayValue)
                ? util_1.CalcUtils.calc(displayValue, this.decorateDisplayValue(value))
                : this.decorateDisplayValue(forceApplyValue ? value : displayValue));
    };
    Object.defineProperty(Field.prototype, "decoratedDisplayValue", {
        /**
         * @stable [19.10.2020]
         * @protected
         */
        get: function () {
            return this.getDecoratedDisplayValue(this.value);
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [18.05.2020]
     * @param {AnyT} value
     * @returns {AnyT}
     */
    Field.prototype.decorateDisplayValue = function (value) {
        return value;
    };
    /**
     * @stable [07.10.2020]
     */
    Field.prototype.getInputElementProps = function () {
        var _this = this;
        var $props = this.originalProps;
        var name = $props.name, tabIndex = $props.tabIndex, _a = $props.type, type = _a === void 0 ? 'text' : _a;
        var _b = this.mergedProps, accept = _b.accept, _c = _b.autoComplete, autoComplete = _c === void 0 ? 'off' : _c, capture = _b.capture, maxLength = _b.maxLength, minLength = _b.minLength;
        var ref = this.inputRef;
        var pattern = this.getFieldPattern();
        var placeholder = util_1.ConditionUtils.orUndef($props.placeholder && !this.isBusy, function () { return _this.t($props.placeholder); });
        var readOnly = this.isInactive;
        var required = this.isRequired;
        var disabled = this.isDisabled;
        var value = this.displayValue;
        return util_1.FilterUtils.defValuesFilter(__assign({ accept: accept,
            autoComplete: autoComplete,
            capture: capture, className: definition_1.FieldClassesEnum.INPUT, disabled: disabled,
            maxLength: maxLength,
            minLength: minLength,
            name: name,
            pattern: pattern,
            placeholder: placeholder,
            readOnly: readOnly,
            ref: ref,
            required: required,
            tabIndex: tabIndex,
            type: type,
            value: value }, (this.isActive
            ? {
                onBlur: this.onBlur,
                onChange: this.onChange,
                onClick: this.onClick,
                onFocus: this.onFocus,
                onKeyDown: this.onKeyDown,
                onKeyUp: this.onKeyUp,
            }
            : {})));
    };
    Object.defineProperty(Field.prototype, "actionsElement", {
        /**
         * @stable [14.10.2020]
         * @protected
         */
        get: function () {
            return null;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [14.10.2020]
     * @protected
     */
    Field.prototype.getInputElement = function () {
        return React.createElement("input", __assign({}, this.getInputElementProps()));
    };
    /**
     * @stable [14.10.2020]
     * @param usePrintf
     * @param args
     * @protected
     */
    Field.prototype.buildDisplayMessage = function (usePrintf) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return usePrintf
            ? Printf.sprintf.apply(Printf, __spreadArrays([this.t(this.originalProps.displayMessage)], args)) : definition_1.FieldConstants.DISPLAY_EMPTY_VALUE;
    };
    /**
     * @stable [14.10.2020]
     * @protected
     */
    Field.prototype.getFieldClassName = function () {
        var _a = this.originalProps, className = _a.className, full = _a.full, label = _a.label;
        return util_1.ClsUtils.joinClassName(definition_1.FieldClassesEnum.FIELD, full && definition_1.FieldClassesEnum.FULL, label && definition_1.FieldClassesEnum.LABELED, this.isBusy && definition_1.FieldClassesEnum.BUSY, this.isChangeable ? definition_1.FieldClassesEnum.CHANGEABLE : definition_1.FieldClassesEnum.NOT_CHANGEABLE, this.isDisabled && definition_1.FieldClassesEnum.DISABLED, this.isFocused ? definition_1.FieldClassesEnum.FOCUSED : definition_1.FieldClassesEnum.NOT_FOCUSED, this.isFocusPrevented && definition_1.FieldClassesEnum.PREVENT_FOCUS, this.isInvalid && definition_1.FieldClassesEnum.INVALID, this.isRequired && definition_1.FieldClassesEnum.REQUIRED, this.isValuePresent ? definition_1.FieldClassesEnum.VALUE_PRESENT : definition_1.FieldClassesEnum.VALUE_NOT_PRESENT, util_1.CalcUtils.calc(className));
    };
    /**
     * @stable [21.08.2020]
     */
    Field.prototype.getLabel = function () {
        return this.originalProps.label;
    };
    /**
     * @stable [21.08.2020]
     */
    Field.prototype.getFieldMask = function () {
        return this.originalProps.mask;
    };
    /**
     * @stable [21.08.2020]
     */
    Field.prototype.getKeyboardProps = function () {
        return this.mergedProps.keyboardConfiguration || {};
    };
    /**
     * @stable [21.08.2020]
     */
    Field.prototype.getComponentsSettingsProps = function () {
        return this.componentsSettings.field;
    };
    Object.defineProperty(Field.prototype, "inputAttachmentElement", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "attachmentElement", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            return util_1.ConditionUtils.ifNotNilThanValue(this.attachmentBodyElement, function (attachmentBodyElement) { return (React.createElement("div", { className: definition_1.FieldClassesEnum.ATTACHMENT }, attachmentBodyElement)); });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "attachmentBodyElement", {
        /**
         * @stable [15.10.2020]
         * @protected
         */
        get: function () {
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "mirrorInputElement", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isCursorUsed", {
        /**
         * @stable [13.10.2020]
         * @protected
         */
        get: function () {
            return this.originalProps.useCursor;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isKeyboardAndCursorUsed", {
        /**
         * @stable [07.10.2020]
         */
        get: function () {
            return this.isKeyboardUsed && this.isCursorUsed;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "emptyValue", {
        /**
         * @stable [07.10.2020]
         */
        get: function () {
            var emptyValue = this.originalProps.emptyValue;
            return util_1.TypeUtils.isDef(emptyValue) ? emptyValue : this.originalEmptyValue;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "originalEmptyValue", {
        /**
         * @stable [07.10.2020]
         */
        get: function () {
            return definition_1.FieldConstants.DISPLAY_EMPTY_VALUE;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "defaultValue", {
        /**
         * @stable [07.10.2020]
         */
        get: function () {
            return this.originalProps.defaultValue;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "displayValue", {
        /**
         * @stable [07.10.2020]
         */
        get: function () {
            return !this.isValuePresent || (this.isFocusPrevented && this.isBusy)
                ? definition_1.FieldConstants.DISPLAY_EMPTY_VALUE
                : this.decoratedDisplayValue;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [14.10.2020]
     * @param value
     */
    Field.prototype.isValueObject = function (value) {
        return util_1.TypeUtils.isObject(value);
    };
    Object.defineProperty(Field.prototype, "isPlainValueApplied", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return this.originalProps.plainValue;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isValuePresent", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return util_1.ValueUtils.isValuePresent(this.value, this.emptyValue);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isValueNotPresent", {
        /**
         * @stable [07.10.2020]
         */
        get: function () {
            return !this.isValuePresent;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [07.10.2020]
     * @param value
     */
    Field.prototype.isValueDefined = function (value) {
        return util_1.TypeUtils.isDef(value);
    };
    Object.defineProperty(Field.prototype, "isFocusPrevented", {
        /**
         * @stable [14.10.2020]
         * @protected
         */
        get: function () {
            return this.originalProps.preventFocus;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isBusy", {
        /**
         * @stable [18.10.2020]
         * @protected
         */
        get: function () {
            return this.originalProps.progress;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isDisabled", {
        /**
         * @stable [18.10.2020]
         */
        get: function () {
            return this.originalProps.disabled;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isReadOnly", {
        /**
         * @stable [18.10.2020]
         */
        get: function () {
            return this.originalProps.readOnly;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isInactive", {
        /**
         * @stable [18.10.2020]
         * @protected
         */
        get: function () {
            return this.isDisabled || this.isReadOnly || this.isBusy;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isDisplayValueDefined", {
        /**
         * @stable [14.10.2020]
         * @protected
         */
        get: function () {
            return util_1.TypeUtils.isDef(this.originalProps.displayValue);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "componentsSettingsProps", {
        /**
         * @stable [14.10.2020]
         * @protected
         */
        get: function () {
            return this.getComponentsSettingsProps();
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [21.06.2020]
     */
    Field.prototype.refreshCaretPosition = function () {
        var _this = this;
        this.setState({ caretPosition: this.caretPosition }, function () { return _this.input.scrollLeft = _this.input.scrollWidth; });
    };
    /**
     * @stable [21.06.2020]
     */
    Field.prototype.setCaretVisibility = function () {
        var _this = this;
        this.setState(function (prevState) { return util_1.FilterUtils.notNilValuesFilter({
            caretVisibility: !prevState.caretVisibility,
            caretPosition: util_1.ConditionUtils.ifNilThanValue(prevState.caretPosition, function () { return _this.caretPosition; }),
        }); });
    };
    /**
     * @stable [21.06.2020]
     * @param {AnyT} rawValue
     */
    Field.prototype.validateField = function (rawValue) {
        this.setState({ error: this.validateValueAndSetCustomValidity(rawValue) });
    };
    /**
     * @stable [21.06.2020]
     * @param {AnyT} value
     * @returns {string}
     */
    Field.prototype.validateValueAndSetCustomValidity = function (value) {
        if (this.hasInput) {
            this.input.setCustomValidity('');
        }
        if (this.isInputValid) {
            return null;
        }
        return this.input.validationMessage;
    };
    /**
     * @stable [21.06.2020]
     */
    Field.prototype.closeVirtualKeyboard = function () {
        this.setState({ keyboardOpen: false }, this.onCloseVirtualKeyboard);
    };
    /**
     * @stable [14.10.2020]
     * @param currentRawValue
     * @private
     */
    Field.prototype.onChangeValue = function (currentRawValue) {
        var originalProps = this.originalProps;
        var name = originalProps.name, onChange = originalProps.onChange, onFormChange = originalProps.onFormChange;
        var actualFieldValue = util_1.FieldUtils.asActualFieldValue(__assign(__assign({}, originalProps), { emptyValue: this.emptyValue, value: currentRawValue }));
        this.validateField(actualFieldValue);
        util_1.ConditionUtils.ifNotNilThanValue(onChange, function () { return onChange(actualFieldValue); });
        util_1.ConditionUtils.ifNotNilThanValue(onFormChange, function () { return onFormChange(name, actualFieldValue); });
    };
    /**
     * @stable [21.06.2020]
     * @param {IBaseEvent} event
     */
    Field.prototype.onDocumentClickHandler = function (event) {
        var keyboardEl = this.keyboardRef.current;
        if (!keyboardEl) {
            return;
        }
        var element = event.target;
        if (this.domAccessor.getParentsAsElements({ parentClassName: definition_1.KeyboardClassNamesEnum.KEYBOARD, element: element })
            .includes(keyboardEl)) {
            return;
        }
        this.closeVirtualKeyboard();
    };
    /**
     * @stable [21.06.2020]
     */
    Field.prototype.onCloseVirtualKeyboard = function () {
        var _this = this;
        util_1.ConditionUtils.ifNotNilThanValue(this.caretBlinkingTask, function (caretBlinkingTask) { return caretBlinkingTask.stop(); });
        util_1.ConditionUtils.ifNotNilThanValue(this.keyboardListenerUnsubscriber, function () {
            _this.keyboardListenerUnsubscriber();
            _this.keyboardListenerUnsubscriber = null;
        });
    };
    /**
     * @stable [21.06.2020]
     * @param {string} rawValue
     */
    Field.prototype.onKeyboardChange = function (rawValue) {
        // Synthetic event creation to reduce source code
        var syntheticEvent = { target: { value: rawValue } };
        // To handle the various field types, NumberField, etc..
        this.onChangeManually(this.getRawValueFromEvent(syntheticEvent));
    };
    /**
     * @stable [21.08.2020]
     * @param message
     * @param className
     */
    Field.prototype.messageElement = function (message, className) {
        return (React.createElement("div", { title: message, className: util_1.ClsUtils.joinClassName(definition_1.FieldClassesEnum.MESSAGE, className) }, message ? this.t(message) : definitions_interface_1.UniCodesEnum.NO_BREAK_SPACE));
    };
    Object.defineProperty(Field.prototype, "selfElement", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            if (this.isFieldRendered) {
                return (React.createElement("div", { ref: this.actualRef, style: this.originalProps.style, title: this.title, className: definition_1.FieldClassesEnum.SELF },
                    this.prefixLabelElement,
                    this.inputWrapperElement,
                    this.actionsElement,
                    this.labelElement,
                    this.progressInfoElement));
            }
            return this.inputWrapperElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "labelElement", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            var _this = this;
            return util_1.ConditionUtils.ifNotNilThanValue(this.getLabel(), function (label) { return (React.createElement("label", { className: definition_1.FieldClassesEnum.LABEL }, _this.t(label))); });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "prefixLabelElement", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return (util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.prefixLabel, function (prefixLabel) { return (React.createElement("span", { className: definition_1.FieldClassesEnum.PREFIX_LABEL }, prefixLabel)); }));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "inputCaretElement", {
        /**
         * @stable [21.06.2020]
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            var _a = this.state, caretPosition = _a.caretPosition, caretVisibility = _a.caretVisibility;
            return util_1.ConditionUtils.ifNotNilThanValue(caretPosition, function () { return util_1.ConditionUtils.orNull(_this.isCursorUsed && _this.isKeyboardOpen && caretVisibility, function () {
                var textOffset = 2;
                var paddingLeft = parseFloat(_this.domAccessor.getProperty(_this.input, 'paddingLeft'));
                var left = caretPosition + paddingLeft - textOffset;
                return (React.createElement("div", { className: definition_1.FieldClassesEnum.INPUT_CARET, style: { left: left } }, "|"));
            }); });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "displayValueElement", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            if (!this.originalProps.displayValueRenderedOnly) {
                return null;
            }
            var result = this.decoratedDisplayValue;
            return R.isNil(result)
                ? (this.isBusy ? this.settings.messages.PLEASE_WAIT : result)
                : result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "progressInfoElement", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            return util_1.ConditionUtils.orNull(this.isBusy, function () {
                return React.createElement(info_component_1.Info, { text: false, progress: true });
            });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "inputWrapperElement", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            if (this.isFieldRendered) {
                return (React.createElement("div", { className: definition_1.FieldClassesEnum.INPUT_WRAPPER },
                    this.getInputElement(),
                    this.mirrorInputElement,
                    this.inputCaretElement,
                    this.inputAttachmentElement));
            }
            return this.inputAttachmentElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "title", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            var _this = this;
            var title = this.originalProps.title;
            return title || util_1.ConditionUtils.orNull(this.isFocusPrevented, function () { return _this.displayValue; });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "caretPosition", {
        /**
         * @stable [14.10.2020]
         * @private
         */
        get: function () {
            var da = this.domAccessor;
            return this.isValuePresent
                ? Math.min(da.getWidth(this.inputMirrorRef.current), da.getWidth(this.input))
                : 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isErrorMessageRendered", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            return util_1.WrapperUtils.isErrorMessageRendered(this.mergedProps);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isInvalid", {
        /**
         * @stable [21.06.2020]
         * @returns {boolean}
         */
        get: function () {
            return !util_1.WrapperUtils.isValid(this.originalProps) || !R.isNil(this.error);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isFocused", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return this.isKeyboardUsed ? this.isKeyboardOpen : this.state.focused;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isInlineKeyboard", {
        /**
         * @stable [21.08.2020]
         */
        get: function () {
            return this.getKeyboardProps().inline;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "hasInput", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return !R.isNil(this.inputRef.current);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isChangeable", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return util_1.WrapperUtils.isChangeable(this.originalProps);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isKeyboardOpen", {
        /**
         * @stable [13.10.2020]
         */
        get: function () {
            return this.state.keyboardOpen || this.isInlineKeyboard;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isFieldRendered", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return this.originalProps.fieldRendered;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isRequired", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return this.originalProps.required;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isInputValid", {
        /**
         * @stable [14.10.2020]
         * @private
         */
        get: function () {
            return !this.hasInput || this.input.validity.valid;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isActive", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return !this.isInactive;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "isKeyboardUsed", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            var useKeyboard = this.originalProps.useKeyboard;
            if (this.mergedProps.useKeyboardOnMobilePlatformOnly) {
                if (this.environment.mobilePlatform) {
                    return useKeyboard;
                }
                else {
                    return false;
                }
            }
            else {
                return useKeyboard;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "areManualChangesPrevented", {
        /**
         * @stable [14.10.2020]
         * @private
         */
        get: function () {
            return this.originalProps.preventManualChanges;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Field.prototype, "error", {
        /**
         * @stable [14.10.2020]
         */
        get: function () {
            return this.state.error;
        },
        enumerable: false,
        configurable: true
    });
    Field.defaultProps = {
        fieldRendered: true,
        plainValue: true,
        useCursor: true,
        full: true,
        useKeyboardOnMobilePlatformOnly: false,
    };
    return Field;
}(enhanced_generic_component_1.EnhancedGenericComponent));
exports.Field = Field;
//# sourceMappingURL=field.component.js.map