/// <reference types="react" />
import { Field } from '../field/field.component';
import { IBaseTextFieldProps, IBaseTextFieldState, IFieldActionEntity } from '../../../definition';
export declare class BaseTextField<TProps extends IBaseTextFieldProps = IBaseTextFieldProps, TState extends IBaseTextFieldState = IBaseTextFieldState> extends Field<TProps, TState> {
    static readonly defaultProps: IBaseTextFieldProps & Partial<import("../../../definition").IGenericComponentProps<any>>;
    private static readonly DEFAULT_MASK_GUIDE;
    protected defaultActions: IFieldActionEntity[];
    /**
     * @stable [14.10.2020]
     * @param originalProps
     */
    constructor(originalProps: TProps);
    /**
     * @stable [30.11.2020]
     * @protected
     */
    protected getInputElement(): JSX.Element;
    /**
     * @stable [18.06.2020]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [12.09.2018]
     * @returns {JSX.Element}
     */
    protected get mirrorInputElement(): JSX.Element;
    /**
     * @stable [09.11.2020]
     * @param action
     * @protected
     */
    protected isFieldActionDisabled(action: IFieldActionEntity): boolean;
    /**
     * @stable [30.11.2020]
     * @private
     */
    private get maskedInputElement();
    /**
     * @stable [09.11.2020]
     * @protected
     */
    protected get actionsElement(): JSX.Element;
    /**
     * @stable [30.10.2019]
     */
    private addClearAction;
    /**
     * @stable [17.06.2020]
     * @returns {IFieldActionEntity[]}
     */
    private get fieldActions();
    /**
     * @stable [21.06.2020]
     * @returns {boolean}
     */
    private get isActioned();
}
