import * as React from 'react';
import { GenericComponent } from '../../base/generic.component';
import { IGridColumnProps } from '../../../definition';
/**
 * @component-impl
 * @stable [09.12.2020]
 */
export declare class BaseGridColumn<TProps extends IGridColumnProps = IGridColumnProps> extends GenericComponent<TProps> {
    static readonly defaultProps: IGridColumnProps;
    /**
     * @stable [08.12.2020]
     * @param style
     * @protected
     */
    protected getStyle(style?: React.CSSProperties): React.CSSProperties;
    /**
     * @stable [08.12.2020]
     * @param classNames
     * @protected
     */
    protected getClassName(...classNames: string[]): string;
    /**
     * @stable [26.11.2020]
     * @protected
     */
    protected isActionable(): boolean;
    /**
     * @stable [09.12.2020]
     * @protected
     */
    protected get isClosable(): boolean;
    /**
     * @stable [08.12.2020]
     * @protected
     */
    protected get columnContentElement(): JSX.Element;
    /**
     * @stable [08.12.2020]
     * @protected
     */
    protected getColumnContentProps(): React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement>;
    /**
     * @stable [08.12.2020]
     * @param children
     * @protected
     */
    protected getColumnContentElement(children: React.ReactNode): React.ReactNode;
}
