"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseGridColumn = void 0;
var React = require("react");
var generic_component_1 = require("../../base/generic.component");
var util_1 = require("../../../util");
var definition_1 = require("../../../definition");
/**
 * @component-impl
 * @stable [09.12.2020]
 */
var BaseGridColumn = /** @class */ (function (_super) {
    __extends(BaseGridColumn, _super);
    function BaseGridColumn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [08.12.2020]
     * @param style
     * @protected
     */
    BaseGridColumn.prototype.getStyle = function (style) {
        return util_1.FilterUtils.defValuesFilter(__assign(__assign({}, style), { width: util_1.NvlUtils.nvl(style && style.width, this.originalProps.width) }));
    };
    /**
     * @stable [08.12.2020]
     * @param classNames
     * @protected
     */
    BaseGridColumn.prototype.getClassName = function () {
        var classNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            classNames[_i] = arguments[_i];
        }
        var _a = this.originalProps, align = _a.align, edited = _a.edited, index = _a.index, indexed = _a.indexed;
        return util_1.ClsUtils.joinClassName.apply(util_1.ClsUtils, __spreadArrays([definition_1.GridClassesEnum.COLUMN, align && "rac-grid-column-align-" + align,
            indexed && util_1.TypeUtils.isNumber(index) && "rac-grid-column-" + index, edited && definition_1.GridClassesEnum.COLUMN_EDITED,
            util_1.NumberUtils.isOddNumber(index) && definition_1.GridClassesEnum.COLUMN_ODD,
            this.isActionable() && definition_1.GridClassesEnum.COLUMN_ACTIONABLE,
            this.isClosable && definition_1.GridClassesEnum.COLUMN_CLOSABLE], classNames));
    };
    /**
     * @stable [26.11.2020]
     * @protected
     */
    BaseGridColumn.prototype.isActionable = function () {
        var sortable = this.originalProps.sortable;
        return sortable;
    };
    Object.defineProperty(BaseGridColumn.prototype, "isClosable", {
        /**
         * @stable [09.12.2020]
         * @protected
         */
        get: function () {
            return this.originalProps.closable;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BaseGridColumn.prototype, "columnContentElement", {
        /**
         * @stable [08.12.2020]
         * @protected
         */
        get: function () {
            var _this = this;
            return util_1.ConditionUtils.ifNotNilThanValue(this.originalChildren, function (children) { return (React.createElement("div", __assign({}, _this.getColumnContentProps()), _this.getColumnContentElement(children))); });
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @stable [08.12.2020]
     * @protected
     */
    BaseGridColumn.prototype.getColumnContentProps = function () {
        return {
            className: definition_1.GridClassesEnum.COLUMN_CONTENT,
        };
    };
    /**
     * @stable [08.12.2020]
     * @param children
     * @protected
     */
    BaseGridColumn.prototype.getColumnContentElement = function (children) {
        return children;
    };
    BaseGridColumn.defaultProps = {};
    return BaseGridColumn;
}(generic_component_1.GenericComponent));
exports.BaseGridColumn = BaseGridColumn;
//# sourceMappingURL=base-grid-column.component.js.map