import * as React from 'react';
import { ILayoutBuilderConfigEntity, LayoutBuilderChildrenNodeT, LayoutBuilderChildrenT } from '../../../definition';
import { UniversalLayoutViewBuilder } from './universal-layout-view.builder';
export declare class LayoutViewBuilder extends UniversalLayoutViewBuilder<LayoutBuilderChildrenNodeT, React.DetailedHTMLProps<React.HTMLAttributes<{}>, {}>> {
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @param {LayoutBuilderChildrenT[]} children
     * @param {ILayoutBuilderConfigEntity} layoutConfig
     * @returns {LayoutBuilderChildrenNodeT}
     */
    buildRowView(props: React.HTMLAttributes<{}>, children: LayoutBuilderChildrenT[], layoutConfig: ILayoutBuilderConfigEntity): LayoutBuilderChildrenNodeT;
    /**
     * @stable [22.10.2018]
     * @param {React.HTMLAttributes<{}>} props
     * @param {LayoutBuilderChildrenT[]} children
     * @param {ILayoutBuilderConfigEntity} layoutConfig
     * @returns {LayoutBuilderChildrenNodeT}
     */
    buildColumnView(props: React.HTMLAttributes<{}>, children: LayoutBuilderChildrenT[], layoutConfig: ILayoutBuilderConfigEntity): LayoutBuilderChildrenNodeT;
    /**
     * @stable [06.04.2020]
     * @param {React.ReactElement<React.Attributes>} item
     * @param {React.ClassAttributes<{}>} props
     * @returns {LayoutBuilderChildrenNodeT}
     */
    cloneItem(item: React.ReactElement<React.Attributes>, props: React.ClassAttributes<{}>): LayoutBuilderChildrenNodeT;
    /**
     * @stable [23.01.2020]
     * @param {ILayoutBuilderConfigEntity} config
     * @returns {string}
     */
    private asFactorClassName;
}
