import { IApiEntity, IFormStoreProxy, IGenericContainer, IGenericContainerProps, IReduxStoreEntity } from '../../../../definition';
import { StoreProxy } from '../store.proxy';
export declare class FormStoreProxy<TStore extends IReduxStoreEntity = IReduxStoreEntity, TProps extends IGenericContainerProps = IGenericContainerProps> extends StoreProxy<TStore, TProps> implements IFormStoreProxy {
    readonly container: IGenericContainer<TProps>;
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    constructor(container: IGenericContainer<TProps>);
    /**
     * @stable [12.04.2020]
     * @param {number} value
     * @param {string} otherSection
     */
    dispatchFormActiveValue(value: number, otherSection?: string): void;
    /**
     * @stable [12.04.2020]
     * @param {number} value
     * @param {string} otherSection
     */
    dispatchFormInactiveValue(value: number, otherSection?: string): void;
    /**
     * @stable [09.10.2019]
     * @param {string} otherSection
     */
    dispatchFormReset(otherSection?: string): void;
    /**
     * @stable [23.04.2020]
     * @param {string} fieldName
     * @param {string} otherSection
     */
    dispatchFormClear(fieldName: string, otherSection?: string): void;
    /**
     * @stable [01.03.2020]
     * @param {IApiEntity} apiEntity
     * @param {string} otherSection
     */
    dispatchFormSubmit(apiEntity: IApiEntity, otherSection?: string): void;
    /**
     * @stable [03.02.2020]
     * @param {boolean} valid
     * @param {string} otherSection
     */
    dispatchFormValid(valid: boolean, otherSection?: string): void;
    /**
     * @stable [09.10.2019]
     * @param {TChanges} changes
     * @param {string} otherSection
     */
    dispatchFormChanges<TChanges = {}>(changes: TChanges, otherSection?: string): void;
    /**
     * @stable [01.04.2020]
     * @param {TChanges} changes
     * @param {string} otherSection
     */
    dispatchFormDefaultChanges<TChanges = {}>(changes: TChanges, otherSection?: string): void;
}
