import { IGenericContainer, IGenericContainerProps, IReduxStoreEntity, IListStoreProxy } from '../../../../definition';
import { StoreProxy } from '../store.proxy';
export declare class ListStoreProxy<TStore extends IReduxStoreEntity = IReduxStoreEntity, TProps extends IGenericContainerProps = IGenericContainerProps> extends StoreProxy<TStore, TProps> implements IListStoreProxy {
    readonly container: IGenericContainer<TProps>;
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    constructor(container: IGenericContainer<TProps>);
    /**
     * @stable [30.03.2020]
     * @param {string} otherSection
     */
    dispatchListCancelLoad(otherSection?: string): void;
    /**
     * @stable [30.03.2020]
     * @param {TEntity} selected
     * @param {string} otherSection
     */
    dispatchListSelect<TEntity>(selected: TEntity, otherSection?: string): void;
    /**
     * @stable [30.03.2020]
     * @param {string} otherSection
     */
    dispatchListCreate(otherSection?: string): void;
}
