"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouterStoreProxy = void 0;
var React = require("react");
var R = require("ramda");
var store_proxy_1 = require("../store.proxy");
var definition_1 = require("../../../../definition");
var action_1 = require("../../../../action");
var util_1 = require("../../../../util");
var RouterStoreProxy = /** @class */ (function (_super) {
    __extends(RouterStoreProxy, _super);
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    function RouterStoreProxy(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        _this.navigateBack = _this.navigateBack.bind(_this);
        return _this;
    }
    /**
     * @stable [06.02.2020]
     * @param {string} path
     */
    RouterStoreProxy.prototype.navigate = function (path) {
        this.dispatchPlainAction(action_1.RouterActionBuilder.buildNavigatePlainAction(path));
    };
    /**
     * @stable [30.03.2020]
     * @param {string} path
     */
    RouterStoreProxy.prototype.rewrite = function (path) {
        this.dispatchPlainAction(action_1.RouterActionBuilder.buildRewritePlainAction(path));
    };
    /**
     * @stable [20.12.2019]
     * @param {number} depth
     */
    RouterStoreProxy.prototype.goBack = function (depth) {
        this.dispatchPlainAction(action_1.RouterActionBuilder.buildNavigateBackPlainAction(depth));
    };
    /**
     * @stable [20.12.2019]
     */
    RouterStoreProxy.prototype.navigateBack = function () {
        this.goBack();
    };
    /**
     * @stable [22.05.2020]
     * @param {(cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element} factory
     * @returns {React.ReactNode[]}
     */
    RouterStoreProxy.prototype.buildNavigationSteps = function (factory) {
        var _this = this;
        var steps = __spreadArrays([
            {
                section: definition_1.DefaultEntities.ROOT_SECTION,
                url: this.settings.routes.home,
            }
        ], (util_1.Selectors.stackItemEntities(this.props) || []));
        var stepsCount = steps.length;
        var hasPrevious = false;
        return util_1.FilterUtils.notNilValuesArrayFilter.apply(util_1.FilterUtils, steps.map(function (item, index) {
            var isFirst = index === 0;
            var isLast = index === stepsCount - 1;
            var isMiddle = !isFirst && !isLast;
            var stepElement = factory({
                first: isFirst,
                hasPrevious: hasPrevious,
                item: item,
                last: isLast,
                middle: isMiddle,
            });
            hasPrevious = !R.isNil(stepElement);
            return util_1.ConditionUtils.ifNotNilThanValue(stepElement, function () { return (React.cloneElement(stepElement, __assign({ key: "navigation-step-key-" + index }, (isLast
                ? {}
                : util_1.PropsUtils.buildClickHandlerProps(function () { return _this.goBack(stepsCount - steps.indexOf(item) - 1); }, true, false))))); });
        }));
    };
    return RouterStoreProxy;
}(store_proxy_1.StoreProxy));
exports.RouterStoreProxy = RouterStoreProxy;
//# sourceMappingURL=router-store.proxy.js.map