/// <reference types="react" />
import { GenericContainer } from '../base/generic.container';
import { ITabPanelContainerProps, ITabPanelProps } from '../../definition';
/**
 * @component-container-impl
 * @stable [30.07.2020]
 *
 * Please use the "Mappers.tabPanelContainerProps"
 */
export declare class TabPanelContainer<TProps extends ITabPanelContainerProps = ITabPanelContainerProps> extends GenericContainer<TProps> {
    /**
     * @stable [30.07.2020]
     * @param originalProps
     */
    constructor(originalProps: TProps);
    /**
     * @stable [30.07.2020]
     */
    render(): JSX.Element;
    /**
     * @stable [12.04.2020]
     * @param {number} value
     */
    protected dispatchActiveValue(value: number): void;
    /**
     * @stable [12.04.2020]
     * @param {number} value
     */
    protected dispatchInactiveValue(value: number): void;
    /**
     * @stable [30.07.2020]
     */
    protected get tabPanelProps(): ITabPanelProps;
    /**
     * @stable [12.04.2020]
     * @param {ITabProps} tab
     */
    private onTabClick;
    /**
     * @stable [12.04.2020]
     * @param {number} activeValue
     */
    private onDeactivate;
}
