/// <reference types="react" />
import { IIconConfigEntity, IUiIconFactory } from '../../../../definition';
export declare class UiIconFactory implements IUiIconFactory {
    private static readonly SUPPORTED_ICONS_MAPS;
    private static readonly ICONS_MAP;
    private readonly alternativeIconCtors;
    /**
     * @stable [19.04.2020]
     * @param {IIconConfigEntity | string} cfg
     * @returns {JSX.Element}
     */
    makeIcon(cfg: IIconConfigEntity | string): JSX.Element;
    /**
     * @stable [19.04.2020]
     * @param {IIconConfigEntity} config
     * @returns {JSX.Element}
     */
    private getAlternativeIconCtor;
    /**
     * @stable [19.04.2020]
     * @param {IIconConfigEntity | string} cfg
     * @returns {IIconConfigEntity}
     */
    private toIconConfig;
}
