import { PhoneNumber as PN, PhoneNumberFormat as PNF } from 'google-libphonenumber';
import { IPhoneConfigEntity, IPhoneConverter } from '../../definition';
export declare class PhoneConverter implements IPhoneConverter<PNF> {
    private readonly settings;
    private readonly phoneUtilInstance;
    /**
     * @stable [30.11.2020]
     * @param cfg
     */
    parse(cfg: IPhoneConfigEntity<PNF>): PN;
    /**
     * @stable [30.11.2020]
     * @param cfg
     */
    format(cfg: IPhoneConfigEntity<PNF>): string;
    /**
     * @stable [30.11.2020]
     * @param cfg
     */
    formatAsInternational(cfg: IPhoneConfigEntity<PNF>): string;
    /**
     * @stable [30.11.2020]
     * @param cfg
     */
    formatAsNational(cfg: IPhoneConfigEntity<PNF>): string;
    /**
     * @stable [30.11.2020]
     * @param cfg
     */
    phoneParameter(cfg: IPhoneConfigEntity<PNF>): string;
    /**
     * @stable [30.11.2020]
     * @param config
     */
    phoneDisplayValue(config: IPhoneConfigEntity<PNF>): string;
    /**
     * @stable [19.09.2020]
     */
    get countryCodeByRegion(): string;
    /**
     * @stable [30.11.2020]
     */
    get countryCodeByRegionDisplayValue(): string;
    /**
     * @stable [19.09.2020]
     */
    private get region();
    /**
     * @stable [19.09.2020]
     */
    private get phoneSettings();
}
