import { AnyT, StringNumberT } from '../definitions.interface';
import { ICryptoManager } from './crypto-manager.interface';
export declare class CryptoManager implements ICryptoManager {
    /**
     * @stable [03.04.2019]
     * @param {AnyT} payload
     * @param {StringNumberT} key
     * @returns {string}
     */
    encrypt(payload: AnyT, key: StringNumberT): string;
    /**
     * @stable [03.04.2019]
     * @param {AnyT} payload
     * @param {StringNumberT} key
     * @param {boolean} stringResult
     * @returns {AnyT}
     */
    decrypt(payload: AnyT, key: StringNumberT, stringResult?: boolean): AnyT;
}
