import { IAliasWrapper, IAsyncLibsWrapper, IDataWrapper, ILoadingWrapper, IUrlWrapper } from '../definitions.interface';
/**
 * @stable [09.01.2020]
 */
export declare enum AsyncLibsEnum {
    GOOGLE_MAPS = "$$GOOGLE_MAPS"
}
/**
 * @stable [09.01.2020]
 */
export interface IAsyncLibPayloadEntity extends IAliasWrapper {
}
/**
 * @config-entity
 * @stable [08.06.2020]
 */
export interface IAsyncLibConfigEntity extends IAliasWrapper, IUrlWrapper {
}
/**
 * @stable [09.01.2020]
 */
export interface IAsyncLibManager {
    cancelWaiting<TPromise>(promise: TPromise): boolean;
    loadLib(cfg: IAsyncLibConfigEntity): Promise<HTMLScriptElement>;
    registerLib(cfg: IAsyncLibConfigEntity): void;
    waitForLib<TPromise>(cfg: IAsyncLibConfigEntity): TPromise;
}
/**
 * @redux-entity
 * @stable [08.06.2020]
 */
export interface IReduxAsyncLibEntity extends IDataWrapper<boolean>, ILoadingWrapper {
}
/**
 * @redux-entity
 * @stable [08.06.2020]
 */
export interface IReduxAsyncLibsEntity {
    [alias: string]: IReduxAsyncLibEntity;
}
/**
 * @redux-holder-entity
 * @stable [08.06.2020]
 */
export interface IReduxAsyncLibsHolderEntity<TEntity = IReduxAsyncLibsEntity> extends IAsyncLibsWrapper<TEntity> {
}
/**
 * @initial-redux-entity
 * @stable [31.07.2020]
 */
export declare const INITIAL_REDUX_ASYNC_LIBS_ENTITY: Readonly<IReduxAsyncLibsEntity>;
/**
 * @stable [08.01.2020]
 */
export declare const $RAC_ASYNC_LIB_LOAD_ACTION_TYPE: string;
export declare const $RAC_ASYNC_LIB_LOAD_DONE_ACTION_TYPE: string;
