import { IDestroySectionsWrapper, ILinkedSectionsWrapper, ILockWrapper, ISectionWrapper, IStackWrapper, IUrlWrapper } from '../definitions.interface';
/**
 * @initial-redux-entity
 * @stable [21.05.2020]
 */
export declare const INITIAL_REDUX_STACK_ENTITY: Readonly<IReduxStackEntity>;
/**
 * @redux-entity
 * @stable [21.05.2020]
 */
export interface IReduxStackItemEntity extends ILinkedSectionsWrapper, ISectionWrapper, IUrlWrapper {
}
/**
 * @redux-entity
 * @stable [21.05.2020]
 */
export interface IReduxStackEntity extends IDestroySectionsWrapper, ILockWrapper, IStackWrapper<IReduxStackItemEntity[]> {
}
/**
 * @redux-holder-entity
 * @stable [21.05.2020]
 */
export interface IReduxStackHolderEntity<TEntity = IReduxStackEntity> extends IStackWrapper<TEntity> {
}
/**
 * @flux-entity
 * @stable [21.05.2020]
 */
export interface IFluxStackEntity extends ISectionWrapper, IUrlWrapper {
}
/**
 * @stable [19.12.2019]
 */
export declare const $RAC_STACK_LOCK_ACTION_TYPE: string;
export declare const $RAC_STACK_POP_ACTION_TYPE: string;
export declare const $RAC_STACK_PUSH_ACTION_TYPE: string;
export declare const $RAC_STACK_REMOVE_ACTION_TYPE: string;
