"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiServices = exports.getReactBootstrapper = exports.getUserActivityManager = exports.getConnectorContainerFactory = exports.getDictionaryStoreProxyFactory = exports.getRouterStoreProxyFactory = exports.getNotificationStoreProxyFactory = exports.getListStoreProxyFactory = exports.getTabPanelStoreProxyFactory = exports.getFormStoreProxyFactory = exports.getStoreProxyFactory = exports.getDialogFormChangesConfirmStoreProxyFactory = exports.getPlaceApi = exports.getAsyncLibManager = exports.getEventManager = exports.getStorage = exports.getEventEmitter = exports.getEnvironment = exports.getTransport = exports.getStore = exports.getDatabaseStorage = exports.getSettings = exports.getTranslator = exports.getUiPlugins = exports.getMultiEntityDatabaseStorage = exports.getDateConverter = exports.getAuth = exports.getDynamicRoutes = exports.getPermissionsManager = exports.getDomAccessor = exports.getNumberConverter = void 0;
var di_interface_1 = require("./di.interface");
var di_support_1 = require("./di.support");
/**
 * @stable [31.10.2018]
 * @returns {INumberConverter}
 */
exports.getNumberConverter = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.NumberConverter); };
/**
 * @stable [19.02.2020]
 * @returns {IDomAccessor}
 */
exports.getDomAccessor = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.DomAccessor); };
/**
 * @stable [30.11.2020]
 */
var getPhoneConverter = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.PhoneConverter); };
/**
 * @stable [16.11.2019]
 * @returns {IPermissionsManager<TAccessConfig>}
 */
exports.getPermissionsManager = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.PermissionsManager);
};
/**
 * @stable [16.11.2019]
 * @returns {DynamicRoutesT}
 */
exports.getDynamicRoutes = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.DynamicRoutes); };
/**
 * @stable [10.09.2020]
 */
var getDynamicSections = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.DynamicSections); };
/**
 * @stable [16.11.2019]
 * @returns {IAuth}
 */
exports.getAuth = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.Auth); };
/**
 * @stable [07.10.2019]
 * @returns {IDateConverter}
 */
exports.getDateConverter = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.DateConverter); };
/**
 * @stable [03.04.2020]
 * @returns {IStorage}
 */
exports.getMultiEntityDatabaseStorage = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.MultiEntityDatabaseStorage); };
/**
 * @stable [18.03.2020]
 * @returns {IUiFactory}
 */
var getUiFactory = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.UiFactory); };
/**
 * @stable [19.06.2020]
 * @returns {IViewerLocator}
 */
var getViewerLocator = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.ViewerLocator); };
/**
 * @stable [21.04.2020]
 * @returns {GenericPluginsMapT}
 */
exports.getUiPlugins = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.UiPlugins); };
/**
 * @stable [15.11.2018]
 * @returns {TranslatorT}
 */
exports.getTranslator = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.Translate); };
/**
 * @stable [29.07.2019]
 * @returns {ISettingsEntity}
 */
exports.getSettings = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.Settings); };
/**
 * @stable [29.07.2019]
 * @returns {IStorage}
 */
exports.getDatabaseStorage = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.DatabaseStorage); };
/**
 * @stable [11.09.2019]
 * @returns {Store<TState>}
 */
exports.getStore = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.Store); };
/**
 * @stable [15.09.2019]
 * @returns {ITransport}
 */
exports.getTransport = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.Transport); };
/**
 * @stable [20.09.2019]
 * @returns {IEnvironment}
 */
exports.getEnvironment = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.Environment); };
/**
 * @stable [17.01.2020]
 * @returns {IEventEmitter}
 */
exports.getEventEmitter = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.EventEmitter); };
/**
 * @stable [24.09.2019]
 * @returns {IStorage}
 */
exports.getStorage = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.Storage); };
/**
 * @stable [24.09.2019]
 * @returns {IEventManager}
 */
exports.getEventManager = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.EventManager); };
/**
 * @stable [09.01.2020]
 * @returns {IAsyncLibManager}
 */
exports.getAsyncLibManager = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.AsyncLibManager); };
/**
 * @stable [09.01.2020]
 * @returns {IPlaceApi}
 */
exports.getPlaceApi = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.PlacesApi); };
/**
 * @stable [27.09.2020]
 */
var getFieldConverter = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.FieldConverter); };
/**
 * @stable [10.09.2020]
 */
var getModifyEntityFactory = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.ModifyEntityFactory); };
/**
 * @stable [27.11.2019]
 * @returns {(parent: IContainer) => }
 */
exports.getDialogFormChangesConfirmStoreProxyFactory = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.DialogFormChangesConfirmStoreProxyFactory);
};
/**
 * @stable [30.03.2020]
 * @returns {StoreProxyFactoryT}
 */
exports.getStoreProxyFactory = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.StoreProxyFactory); };
/**
 * @stable [30.11.2019]
 * @returns {FormStoreProxyFactoryT}
 */
exports.getFormStoreProxyFactory = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.FormStoreProxyFactory); };
/**
 * @stable [12.04.2020]
 * @returns {TabPanelStoreProxyFactoryT}
 */
exports.getTabPanelStoreProxyFactory = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.TabPanelStoreProxyFactory); };
/**
 * @stable [30.03.2020]
 * @returns {ListStoreProxyFactoryT}
 */
exports.getListStoreProxyFactory = function () { return di_support_1.staticInjector(di_interface_1.DI_TYPES.ListStoreProxyFactory); };
/**
 * @stable [30.03.2020]
 * @returns {NotificationStoreProxyFactoryT}
 */
exports.getNotificationStoreProxyFactory = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.NotificationStoreProxyFactory);
};
/**
 * @stable [18.12.2019]
 * @returns {RouterStoreProxyFactoryT}
 */
exports.getRouterStoreProxyFactory = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.RouterStoreProxyFactory);
};
/**
 * @stable [29.02.2020]
 * @returns {DictionaryStoreProxyFactoryT}
 */
exports.getDictionaryStoreProxyFactory = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.DictionaryStoreProxyFactory);
};
/**
 * @stable [19.12.2019]
 * @returns {IConnectorContainerFactory}
 */
exports.getConnectorContainerFactory = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.ConnectorContainerFactory);
};
/**
 * @stable [19.01.2020]
 * @returns {IUserActivityManager}
 */
exports.getUserActivityManager = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.UserActivityManager);
};
/**
 * @stable [17.06.2020]
 * @returns {IBootstrapper}
 */
var getWebBootstrapper = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.WebBootstrapper);
};
/**
 * @stable [17.06.2020]
 * @returns {IBootstrapper}
 */
exports.getReactBootstrapper = function () {
    return di_support_1.staticInjector(di_interface_1.DI_TYPES.ReactBootstrapper);
};
/**
 * @stable [11.06.2020]
 */
var DiServices = /** @class */ (function () {
    function DiServices() {
    }
    DiServices.auth = exports.getAuth;
    DiServices.dateConverter = exports.getDateConverter;
    DiServices.dynamicRoutes = exports.getDynamicRoutes;
    DiServices.dynamicSections = getDynamicSections;
    DiServices.environment = exports.getEnvironment;
    DiServices.fieldConverter = getFieldConverter;
    DiServices.modifyEntityFactory = getModifyEntityFactory;
    DiServices.numberConverter = exports.getNumberConverter;
    DiServices.phoneConverter = getPhoneConverter;
    DiServices.reactBootstrapper = exports.getReactBootstrapper;
    DiServices.settings = exports.getSettings;
    DiServices.store = exports.getStore;
    DiServices.translator = exports.getTranslator;
    DiServices.uiFactory = getUiFactory;
    DiServices.viewerLocator = getViewerLocator;
    DiServices.webBootstrapper = getWebBootstrapper;
    return DiServices;
}());
exports.DiServices = DiServices;
//# sourceMappingURL=di.services.js.map