import { AnyT, IKeyValue } from '../definitions.interface';
import { IEnvironment } from '../definition';
export declare class Environment implements IEnvironment {
    private static readonly logger;
    readonly appProfile: string;
    readonly appVersion: string;
    readonly basePath: string;
    readonly devMode: boolean;
    readonly document: Document;
    readonly host: string;
    readonly normalizedBasePath: string;
    readonly port: string;
    readonly prodMode: boolean;
    readonly window: Window;
    /**
     * @stable [08.10.2019]
     */
    constructor();
    /**
     * @stable [09.01.2020]
     * @returns {string}
     */
    get googleMapsKey(): string;
    /**
     * @stable [19.12.2019]
     * @returns {string}
     */
    get path(): string;
    /**
     * @stable [13.03.2020]
     * @returns {string}
     */
    get fullPath(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get platformType(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get appNamespace(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get googleKey(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get browserVersion(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get browserName(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get platformVersion(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get platformName(): string;
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    get passwordPlaceholder(): string;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get mobilePlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get windowsPhonePlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get safariPlatform(): boolean;
    /**
     * @stable [21.01.2020]
     * @returns {boolean}
     */
    get safariMobilePlatform(): boolean;
    /**
     * @stable [21.01.2020]
     * @returns {boolean}
     */
    get safariOrSafariMobilePlatform(): boolean;
    /**
     * @stable [16.01.2020]
     * @returns {boolean}
     */
    get touchedPlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get chromePlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get windowsPlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get macPlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get androidPlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get ios13Platform(): boolean;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    get iosPlatform(): boolean;
    /**
     * @stable [08.10.2019]
     * @param {string} name
     * @param {AnyT} scope
     */
    setVariable(name: string, scope: AnyT): void;
    /**
     * @stable [13.03.2020]
     * @param {string} sectionRoute
     * @returns {string}
     */
    getSectionFullPath(sectionRoute: string): string;
    /**
     * @stable [13.03.2020]
     * @returns {TParams}
     */
    getUrlQueryParams<TParams = IKeyValue>(): TParams;
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    private get isMacPlatform();
    /**
     * @stable [08.10.2019]
     * @returns {string}
     */
    private get osFamily();
}
