"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UniversalStorageEffects = void 0;
var R = require("ramda");
var redux_effects_promise_1 = require("redux-effects-promise");
var ts_smart_logger_1 = require("ts-smart-logger");
var di_1 = require("../di");
var definition_1 = require("../definition");
var util_1 = require("../util");
var UniversalStorageEffects = /** @class */ (function () {
    /**
     * @stable [17.11.2019]
     */
    function UniversalStorageEffects() {
        this.isPreviousStatesAlreadyCleared = false;
        this.doSyncState = this.doSyncState.bind(this);
    }
    UniversalStorageEffects_1 = UniversalStorageEffects;
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    UniversalStorageEffects.prototype.$onAppSyncState = function () {
        return this.doSyncState();
    };
    /**
     * @stable [17.11.2019]
     */
    UniversalStorageEffects.prototype.$onRegisterSyncStateTask = function () {
        var _this = this;
        var appStateSyncTimeout = this.storageSettings.appStateSyncTimeout;
        if (appStateSyncTimeout === 0) {
            return;
        }
        this.doUnRegisterSyncStateTask();
        this.syncStateWithStorageTask = new util_1.DelayedTask(this.doSyncState, appStateSyncTimeout);
        this.syncStateWithStorageTaskUnsubscriber = this.appStore.subscribe(function () { return _this.syncStateWithStorageTask.start(); });
        UniversalStorageEffects_1.logger.debug("[UniversalStorageEffects][$onRegisterSyncStateTask] The sync task has been register successfully");
    };
    /**
     * @stable [17.11.2019]
     */
    UniversalStorageEffects.prototype.$onUnRegisterSyncStateTask = function () {
        this.doUnRegisterSyncStateTask(false);
    };
    /**
     * @stable [18.11.2019]
     * @param {boolean} silently
     */
    UniversalStorageEffects.prototype.doUnRegisterSyncStateTask = function (silently) {
        if (silently === void 0) { silently = true; }
        if (!R.isNil(this.syncStateWithStorageTask)) {
            this.syncStateWithStorageTask.stop();
            this.syncStateWithStorageTask = null;
            if (!silently) {
                UniversalStorageEffects_1.logger.debug("[UniversalStorageEffects][doUnRegisterSyncStateTask] The sync task has been unregister successfully");
            }
        }
        if (util_1.isFn(this.syncStateWithStorageTaskUnsubscriber)) {
            this.syncStateWithStorageTaskUnsubscriber();
            this.syncStateWithStorageTaskUnsubscriber = null;
        }
    };
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    UniversalStorageEffects.prototype.doSyncState = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.syncState()];
                    case 1:
                        _a.sent();
                        UniversalStorageEffects_1.logger.debug("[UniversalStorageEffects][doSyncState] The app state has been synced with storage successfully");
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        this.logManager.send(definition_1.StorageEventCategoriesEnum.STORAGE_ERROR, definition_1.StorageEventsEnum.SYNC_APP_STATE, e_1.message);
                        UniversalStorageEffects_1.logger.error("[UniversalStorageEffects][doSyncState] Error:", e_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    UniversalStorageEffects.prototype.syncState = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.clearPreviousStates()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.storage.set(this.appStateKeyName, this.stateSerializer.serialize(this.appStore.getState()))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    UniversalStorageEffects.prototype.clearPreviousStates = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tasksToClearPreviousStates, tasksKeys;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isPreviousStatesAlreadyCleared) {
                            return [2 /*return*/];
                        }
                        this.isPreviousStatesAlreadyCleared = true;
                        tasksToClearPreviousStates = [];
                        tasksKeys = [];
                        this.storage.each(function (value, key) {
                            if (key.endsWith(_this.appStateKeyName)) {
                                tasksKeys.push(key);
                                tasksToClearPreviousStates.push(_this.storage.remove(key, true));
                            }
                        });
                        if (!(tasksToClearPreviousStates.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, Promise.resolve(tasksToClearPreviousStates)];
                    case 1:
                        _a.sent();
                        UniversalStorageEffects_1.logger.debug("[UniversalStorageEffects][clearPreviousStates] The previous states has been cleared successfully. Keys:", JSON.stringify(tasksKeys));
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(UniversalStorageEffects.prototype, "storageSettings", {
        /**
         * @stable [17.11.2019]
         * @returns {IStorageSettingsEntity}
         */
        get: function () {
            return this.settings.storage || {};
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(UniversalStorageEffects.prototype, "appStateKeyName", {
        /**
         * @stable [17.11.2019]
         * @returns {string}
         */
        get: function () {
            return this.storageSettings.appStateKeyName || '$$rac.state.default';
        },
        enumerable: false,
        configurable: true
    });
    var UniversalStorageEffects_1;
    UniversalStorageEffects.logger = ts_smart_logger_1.LoggerFactory.makeLogger('UniversalStorageEffects');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.LogManager),
        __metadata("design:type", Object)
    ], UniversalStorageEffects.prototype, "logManager", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], UniversalStorageEffects.prototype, "settings", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.StateSerializer),
        __metadata("design:type", Object)
    ], UniversalStorageEffects.prototype, "stateSerializer", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Storage),
        __metadata("design:type", Object)
    ], UniversalStorageEffects.prototype, "storage", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Store),
        __metadata("design:type", Object)
    ], UniversalStorageEffects.prototype, "appStore", void 0);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(definition_1.$RAC_STORAGE_SYNC_APP_STATE_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Promise)
    ], UniversalStorageEffects.prototype, "$onAppSyncState", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(definition_1.$RAC_STORAGE_REGISTER_SYNC_APP_STATE_TASK_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], UniversalStorageEffects.prototype, "$onRegisterSyncStateTask", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(definition_1.$RAC_STORAGE_UNREGISTER_SYNC_APP_STATE_TASK_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], UniversalStorageEffects.prototype, "$onUnRegisterSyncStateTask", null);
    UniversalStorageEffects = UniversalStorageEffects_1 = __decorate([
        di_1.provideInSingleton(UniversalStorageEffects_1),
        __metadata("design:paramtypes", [])
    ], UniversalStorageEffects);
    return UniversalStorageEffects;
}());
exports.UniversalStorageEffects = UniversalStorageEffects;
//# sourceMappingURL=universal-storage.effects.js.map