"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultFormChangesMiddlewareFactories = void 0;
var action_1 = require("../../action");
var util_1 = require("../../util");
/**
 * @stable [19.09.2020]
 * @param cfg
 */
var makeDefaultFormChangesMiddleware = function (cfg) {
    var defaultChanges = cfg.defaultChanges;
    var formSection = util_1.SectionUtils.asFormSection(cfg);
    return util_1.ConditionUtils.orNull(util_1.ObjectUtils.isObjectNotEmpty(defaultChanges) && util_1.ObjectUtils.isObjectNotEmpty(formSection), function () { return action_1.FormActionBuilder.buildDefaultChangesAction(formSection, util_1.CalcUtils.calc(defaultChanges, cfg)); });
};
/**
 * @stable [19.09.2020]
 */
var DefaultFormChangesMiddlewareFactories = /** @class */ (function () {
    function DefaultFormChangesMiddlewareFactories() {
    }
    DefaultFormChangesMiddlewareFactories.defaultFormChangesMiddleware = makeDefaultFormChangesMiddleware;
    return DefaultFormChangesMiddlewareFactories;
}());
exports.DefaultFormChangesMiddlewareFactories = DefaultFormChangesMiddlewareFactories;
//# sourceMappingURL=default-form-changes.middleware.js.map