"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Base64Utils = void 0;
var js_base64_1 = require("js-base64");
var json_1 = require("./json");
/**
 * @stable [11.12.2020]
 * @param str
 */
var stringToBase64 = function (str) { return js_base64_1.Base64.encode(str); };
/**
 * @stable [11.12.2020]
 * @param o
 */
var jsonToBase64 = function (o) { return stringToBase64(json_1.JsonUtils.serializeJson(o)); };
/**
 * @stable [11.12.2020]
 * @param base64
 */
var base64ToString = function (base64) { return js_base64_1.Base64.decode(base64); };
/**
 * @stable [10.12.2020]
 * @param base64
 */
var base64ToJson = function (base64) { return json_1.JsonUtils.parseJson(base64ToString(base64)); };
/**
 * @stable [10.12.2020]
 */
var Base64Utils = /** @class */ (function () {
    function Base64Utils() {
    }
    Base64Utils.base64ToJson = base64ToJson;
    Base64Utils.base64ToString = base64ToString;
    Base64Utils.jsonToBase64 = jsonToBase64;
    Base64Utils.stringToBase64 = stringToBase64;
    return Base64Utils;
}());
exports.Base64Utils = Base64Utils;
//# sourceMappingURL=base64.js.map