"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MapAsComponentUtils = void 0;
var R = require("ramda");
var definition_1 = require("../definition");
var definitions_interface_1 = require("../definitions.interface");
var cond_1 = require("./cond");
var filter_1 = require("./filter");
var map_as_original_1 = require("./map-as-original");
var map_as_1 = require("./map-as");
var select_1 = require("./select");
/**
 * @map-as-component
 *
 * @stable [30.07.2020]
 * @param tabPanel
 */
var mapTabPanelProps = function (tabPanel) {
    return map_as_original_1.MapAsOriginalUtils.activeValueHolderEntity(tabPanel);
};
/**
 * @map-as-component
 *
 * @stable [31.07.2020]
 * @param searchToolbar
 */
var mapSearchToolbarProps = function (searchToolbar) {
    return map_as_original_1.MapAsOriginalUtils.queryFilterEntity(searchToolbar);
};
/**
 * @map-as-component
 *
 * @stable [31.07.2020]
 * @param pageToolbar
 */
var mapPageToolbarProps = function (pageToolbar) {
    return map_as_original_1.MapAsOriginalUtils.paginatedLifeCycleEntity(pageToolbar);
};
/**
 * @map-as-component
 *
 * @stable [31.07.2020]
 * @param form
 */
var mapFormProps = function (form) {
    return map_as_original_1.MapAsOriginalUtils.extendedFormEntity(form);
};
/**
 * @map-as-component
 *
 * @stable [01.08.2020]
 * @param unsavedFormChangesDialog
 */
var mapUnsavedFormChangesDialogProps = function (unsavedFormChangesDialog) {
    return map_as_original_1.MapAsOriginalUtils.formHolderEntity(unsavedFormChangesDialog);
};
/**
 * @map-as-component
 *
 * @stable [01.08.2020]
 * @param toolbarTools
 */
var mapToolbarToolsProps = function (toolbarTools) {
    return cond_1.ConditionUtils.ifNotNilThanValue(toolbarTools, function () { return filter_1.FilterUtils.defValuesFilter({
        disabled: toolbarTools.disabled,
        activeTools: toolbarTools.activeTools,
    }); }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @map-as-container
 *
 * @stable [30.07.2020]
 * @param tabPanelContainer
 */
var mapTabPanelContainerProps = function (tabPanelContainer) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.tabPanelHolderEntity(tabPanelContainer)), map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(tabPanelContainer))); };
/**
 * @map-as-container
 *
 * @stable [31.07.2020]
 * @param pageToolbarContainer
 */
var mapPageToolbarContainerProps = function (pageToolbarContainer) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.listHolderEntity(pageToolbarContainer)), map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(pageToolbarContainer))); };
/**
 * @map-entity-as-container
 *
 * @stable [06.08.2020]
 * @param proxyContainer
 */
var mapContainerAsUnsavedFormChangesDialogContainerProps = function (proxyContainer) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.formHolderEntity(proxyContainer.props)), { proxyContainer: proxyContainer })); };
/**
 * @map-as-container
 *
 * @stable [30.07.2020]
 * @param formTabPanelContainer
 */
var mapFormTabPanelContainerProps = function (formTabPanelContainer) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.formHolderEntity(formTabPanelContainer)), map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(formTabPanelContainer))); };
/**
 * @map-as-container
 *
 * @stable [30.07.2020]
 * @param formContainer
 */
var mapFormContainerProps = function (formContainer) {
    return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.extendedFormEntity(formContainer)), map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(formContainer)));
};
/**
 * @map-as-container
 *
 * @stable [31.07.2020]
 * @param listContainer
 */
var mapListContainerProps = function (listContainer) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.listHolderEntity(listContainer)), map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(listContainer))); };
/**
 * @map-as-container
 *
 * @stable [31.07.2020]
 * @param searchToolbarContainer
 */
var mapSearchToolbarContainerProps = function (searchToolbarContainer) { return (__assign(__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.listHolderEntity(searchToolbarContainer)), map_as_original_1.MapAsOriginalUtils.queryFilterHolderEntity(searchToolbarContainer)), map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(searchToolbarContainer))); };
/**
 * @map-as-container
 *
 * @stable [01.08.2020]
 * @param toolbarToolsContainer
 */
var mapToolbarToolsContainerProps = function (toolbarToolsContainer) { return (__assign(__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.formHolderEntity(toolbarToolsContainer)), map_as_original_1.MapAsOriginalUtils.listHolderEntity(toolbarToolsContainer)), map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(toolbarToolsContainer))); };
/**
 * @map-as-container
 *
 * @stable [01.08.2020]
 * @param defaultLayoutContainer
 */
var mapDefaultLayoutContainerProps = function (defaultLayoutContainer) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(defaultLayoutContainer)), map_as_original_1.MapAsOriginalUtils.storeEntity(defaultLayoutContainer))); };
/**
 * @map-as-container
 *
 * @stable [02.08.2020]
 * @param filterFormDialogContainer
 */
var mapFilterFormDialogContainerProps = function (filterFormDialogContainer) {
    return mapFormContainerProps(filterFormDialogContainer);
};
/**
 * @map-container-as-component
 *
 * @stable [30.07.2020]
 * @param tabPanelContainer
 */
var mapTabPanelContainerPropsAsTabPanelProps = function (tabPanelContainer) { return (__assign(__assign({}, mapTabPanelProps(select_1.Selectors.tabPanel(tabPanelContainer))), tabPanelContainer.tabPanelConfiguration)); };
/**
 * @map-container-as-component
 *
 * @stable [30.07.2020]
 * @param formTabPanelContainer
 */
var mapFormTabPanelContainerPropsAsTabPanelProps = function (formTabPanelContainer) { return (__assign(__assign({}, mapTabPanelProps(select_1.Selectors.form(formTabPanelContainer))), formTabPanelContainer.tabPanelConfiguration)); };
/**
 * @map-container-as-component
 *
 * @stable [31.07.2020]
 * @param formContainer
 */
var mapFormContainerPropsAsFormProps = function (formContainer) { return (__assign(__assign({}, mapFormProps(formContainer)), formContainer.formConfiguration)); };
/**
 * @map-container-as-component
 *
 * @stable [31.07.2020]
 * @param pageToolbarContainer
 */
var mapPageToolbarContainerPropsAsPageToolbarProps = function (pageToolbarContainer) {
    return (__assign(__assign({}, mapPageToolbarProps(select_1.Selectors.list(pageToolbarContainer))), pageToolbarContainer.toolbarConfiguration));
};
/**
 * @map-component-as-component
 *
 * @stable [12.08.2020]
 * @param defaultLayout
 */
var mapDefaultLayoutPropsAsHeaderProps = function (defaultLayout) {
    return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.storeEntity(defaultLayout)), defaultLayout.headerConfiguration));
};
/**
 * @map-component-as-component
 *
 * @stable [17.08.2020]
 * @param list
 */
var mapListPropsAsBasicListProps = function (list) {
    return filter_1.FilterUtils.defValuesFilter({
        className: list.className,
        full: list.full,
    });
};
/**
 * @map-container-as-component
 *
 * @stable [31.07.2020]
 * @param searchToolbarContainer
 */
var mapSearchToolbarContainerPropsAsSearchToolbarProps = function (searchToolbarContainer) { return (__assign(__assign(__assign({}, mapSearchToolbarProps(select_1.Selectors.queryFilter(searchToolbarContainer))), searchToolbarContainer.toolbarConfiguration), map_as_1.MapAsUtils.listHolderEntityAsDisabled(searchToolbarContainer))); };
/**
 * @map-container-as-component
 *
 * @stable [01.08.2020]
 * @param toolbarToolsContainer
 */
var mapToolbarToolsContainerPropsAsToolbarToolsProps = function (toolbarToolsContainer) { return (__assign(__assign(__assign({}, mapToolbarToolsProps({
    activeTools: select_1.Selectors.activeToolbarToolsFromDirtyWrapper(select_1.Selectors.form(toolbarToolsContainer)),
})), toolbarToolsContainer.toolbarToolsConfiguration), map_as_1.MapAsUtils.listHolderEntityAsDisabled(toolbarToolsContainer))); };
/**
 * @map-container-as-component
 *
 * @stable [01.08.2020]
 * @param unsavedFormChangesDialogContainer
 */
var mapUnsavedFormChangesDialogContainerPropsAsUnsavedFormChangesDialogProps = function (unsavedFormChangesDialogContainer) {
    return (__assign(__assign({}, mapUnsavedFormChangesDialogProps(unsavedFormChangesDialogContainer)), unsavedFormChangesDialogContainer.dialogConfiguration));
};
/**
 * @map-entity-as-container
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapPrimaryFilterExtendedFormEntityAsFormContainerProps = function (entity) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(entity)), select_1.Selectors.primaryFilter(entity))); };
/**
 * @map-entity-as-container
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapSecondaryFilterExtendedFormEntityAsFormContainerProps = function (entity) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(entity)), select_1.Selectors.secondaryFilter(entity))); };
/**
 * @map-entity-as-container
 *
 * @stable [01.08.2020]
 * @param entity
 */
var mapPrimaryFilterFormHolderEntityAsToolbarToolsContainerProps = function (entity) {
    return mapToolbarToolsContainerProps(__assign(__assign({}, select_1.Selectors.primaryFilter(entity)), entity));
};
/**
 * @map-entity-as-container
 *
 * @stable [01.08.2020]
 * @param entity
 */
var mapSecondaryFilterFormHolderEntityAsToolbarToolsContainerProps = function (entity) {
    return mapToolbarToolsContainerProps(__assign(__assign({}, select_1.Selectors.secondaryFilter(entity)), entity));
};
/**
 * @map-entity-as-container
 *
 * @stable [02.08.2020]
 * @param entity
 */
var mapSecondaryFilterExtendedFormEntityAsFilterFormDialogContainerProps = function (entity) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(entity)), select_1.Selectors.secondaryFilter(entity))); };
/**
 * @map-entity-as-container
 *
 * @stable [02.08.2020]
 * @param entity
 */
var mapPrimaryFilterExtendedFormEntityAsFilterFormDialogContainerProps = function (entity) { return (__assign(__assign({}, map_as_original_1.MapAsOriginalUtils.sectionNameWrapper(entity)), select_1.Selectors.primaryFilter(entity))); };
/**
 * @map-container-as-component
 *
 * @stable [07.08.2020]
 * @param cfg
 */
var mapDictionariesContainerAsSelectProps = function (cfg) {
    return (__assign(__assign({}, map_as_1.MapAsUtils.dictionaryEntityAsSelectEntity(cfg.dictionaryEntityResolver(cfg.container.props.dictionaries), cfg.dataResolver)), { onDictionaryLoad: function (items) {
            var noAvailableItemsToSelect = cfg.container.settings.messages.NO_AVAILABLE_ITEMS_TO_SELECT;
            if (noAvailableItemsToSelect && R.isEmpty(items)) {
                cfg.container.notificationStoreProxy.dispatchNotification(noAvailableItemsToSelect);
            }
        }, onDictionaryChange: cfg.container.dictionaryStoreProxy.dispatchLoadDictionaryOnChange }));
};
/**
 * @map-container-as-component
 *
 * @stable [07.08.2020]
 * @param cfg
 */
var mapDictionariesContainerAsParameterizedSelectProps = function (cfg) {
    var originalProps = mapDictionariesContainerAsSelectProps(cfg);
    var buildParameterizedPayloadWrapper = function (payloadWrapper) {
        if (payloadWrapper === void 0) { payloadWrapper = {}; }
        return R.mergeDeepLeft({
            payload: cfg.payloadResolver(),
        }, payloadWrapper);
    };
    return __assign(__assign({}, originalProps), { onDictionaryChange: function (_, payloadWrapper) {
            return originalProps.onDictionaryChange(_, buildParameterizedPayloadWrapper(payloadWrapper));
        } });
};
/**
 * @map-container-as-component
 *
 * @stable [07.08.2020]
 * @param container
 */
var mapDictionariesContainerAsPlaceFieldProps = function (container) { return (__assign(__assign({}, map_as_1.MapAsUtils.dictionaryEntityAsSelectEntity(container.props.dictionaries.places)), { dictionary: definition_1.DictionariesEnum.PLACES, onDictionaryChange: container.dictionaryStoreProxy.dispatchLoadDictionaryOnChange })); };
/**
 * @stable [30.07.2020]
 */
var MapAsComponentUtils = /** @class */ (function () {
    function MapAsComponentUtils() {
    }
    MapAsComponentUtils.containerAsUnsavedFormChangesDialogContainerProps = mapContainerAsUnsavedFormChangesDialogContainerProps;
    MapAsComponentUtils.defaultLayoutContainerProps = mapDefaultLayoutContainerProps;
    MapAsComponentUtils.defaultLayoutPropsAsHeaderProps = mapDefaultLayoutPropsAsHeaderProps;
    MapAsComponentUtils.dictionariesContainerAsParameterizedSelectProps = mapDictionariesContainerAsParameterizedSelectProps;
    MapAsComponentUtils.dictionariesContainerAsPlaceFieldProps = mapDictionariesContainerAsPlaceFieldProps;
    MapAsComponentUtils.dictionariesContainerAsSelectProps = mapDictionariesContainerAsSelectProps;
    MapAsComponentUtils.filterFormDialogContainerProps = mapFilterFormDialogContainerProps;
    MapAsComponentUtils.formContainerProps = mapFormContainerProps;
    MapAsComponentUtils.formContainerPropsAsFormProps = mapFormContainerPropsAsFormProps;
    MapAsComponentUtils.formTabPanelContainerProps = mapFormTabPanelContainerProps;
    MapAsComponentUtils.formTabPanelContainerPropsAsTabPanelProps = mapFormTabPanelContainerPropsAsTabPanelProps;
    MapAsComponentUtils.listContainerProps = mapListContainerProps;
    MapAsComponentUtils.listPropsAsBasicListProps = mapListPropsAsBasicListProps;
    MapAsComponentUtils.pageToolbarContainerProps = mapPageToolbarContainerProps;
    MapAsComponentUtils.pageToolbarContainerPropsAsPageToolbarProps = mapPageToolbarContainerPropsAsPageToolbarProps;
    MapAsComponentUtils.primaryFilterExtendedFormEntityAsFilterFormDialogContainerProps = mapPrimaryFilterExtendedFormEntityAsFilterFormDialogContainerProps;
    MapAsComponentUtils.primaryFilterExtendedFormEntityAsFormContainerProps = mapPrimaryFilterExtendedFormEntityAsFormContainerProps;
    MapAsComponentUtils.primaryFilterFormHolderEntityAsToolbarToolsContainerProps = mapPrimaryFilterFormHolderEntityAsToolbarToolsContainerProps;
    MapAsComponentUtils.searchToolbarContainerProps = mapSearchToolbarContainerProps;
    MapAsComponentUtils.searchToolbarContainerPropsAsSearchToolbarProps = mapSearchToolbarContainerPropsAsSearchToolbarProps;
    MapAsComponentUtils.secondaryFilterExtendedFormEntityAsFilterFormDialogContainerProps = mapSecondaryFilterExtendedFormEntityAsFilterFormDialogContainerProps;
    MapAsComponentUtils.secondaryFilterExtendedFormEntityAsFormContainerProps = mapSecondaryFilterExtendedFormEntityAsFormContainerProps;
    MapAsComponentUtils.secondaryFilterFormHolderEntityAsToolbarToolsContainerProps = mapSecondaryFilterFormHolderEntityAsToolbarToolsContainerProps;
    MapAsComponentUtils.tabPanelContainerProps = mapTabPanelContainerProps;
    MapAsComponentUtils.tabPanelContainerPropsAsTabPanelProps = mapTabPanelContainerPropsAsTabPanelProps;
    MapAsComponentUtils.toolbarToolsContainerProps = mapToolbarToolsContainerProps;
    MapAsComponentUtils.toolbarToolsContainerPropsAsToolbarToolsProps = mapToolbarToolsContainerPropsAsToolbarToolsProps;
    MapAsComponentUtils.toolbarToolsProps = mapToolbarToolsProps;
    MapAsComponentUtils.unsavedFormChangesDialogContainerPropsAsUnsavedFormChangesDialogProps = mapUnsavedFormChangesDialogContainerPropsAsUnsavedFormChangesDialogProps;
    MapAsComponentUtils.unsavedFormChangesDialogProps = mapUnsavedFormChangesDialogProps;
    return MapAsComponentUtils;
}());
exports.MapAsComponentUtils = MapAsComponentUtils;
//# sourceMappingURL=map-as-component.js.map