"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringUtils = void 0;
var camelcase_1 = require("camelcase");
var definitions_interface_1 = require("../definitions.interface");
var cond_1 = require("./cond");
var type_1 = require("./type");
var object_1 = require("./object");
/**
 * @stable [25.07.2020]
 * @param value
 * @param options
 */
var asCamelcase = function (value, options) {
    return camelcase_1.default(value, options);
};
/**
 * @stable [14.08.2020]
 * @param value
 * @param returnUndef
 */
var asStringParameter = function (value, returnUndef) {
    if (returnUndef === void 0) { returnUndef = false; }
    return cond_1.ConditionUtils.ifNotNilThanValue(value, function () {
        var resultValue = value;
        if (type_1.TypeUtils.isString(value)) {
            resultValue = value.trim();
        }
        return object_1.ObjectUtils.isObjectNotEmpty(resultValue)
            ? String(resultValue)
            : (returnUndef ? definitions_interface_1.UNDEF : null);
    }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @stable [25.07.2020]
 */
var StringUtils = /** @class */ (function () {
    function StringUtils() {
    }
    StringUtils.asCamelcase = asCamelcase;
    StringUtils.asStringParameter = asStringParameter;
    return StringUtils;
}());
exports.StringUtils = StringUtils;
//# sourceMappingURL=string.js.map